#ifndef __ACTION_H
#define __ACTION_H

#define MAX_ARGS 3
typedef enum {
	T_WORD,		/* command or argument */
        T_ARGSTART,	/* start of argument list */
        T_ARGEND,	/* end of argument list */
        T_SHELL,	/* a shell command */
	T_ERROR,	/* error */
	T_EOF		/* '\n' */
} TOKEN;
typedef enum {
	E_NONE,		/* NO ERROR */
	E_NOTIME,	/* NO TIME */
	E_NOANSWER,	/* NO ANSWER */
        E_PARSE_FAIL,   /* File parsing failed */
	E_CMD,		/* COMMAND LINE ERROR */
        E_INSUFF,	/* Insufficient number of arguments */
            /* load_file() error conditions */
	E_INPUTFILEFAIL,/* Input file read failed (check permission/existence)*/
	E_LOGFILEFAIL,	/* Log file creation failed */
	E_LOADED,	/* Input File already loaded 
                            (only 1 file can be loaded in each session)*/
        E_INCOMPAT,	/* Incompatible graphs for merging */
	E_INVNAME,	/* Invalid new name for graph declaration */
        E_EMPTY,	/* Empty graph(s) for merging */
        E_UNDECL,	/* Undeclared graphs */
        E_DECL,		/* Declared graphs */
        E_RESET_FAIL,	/* Reset graph failed */
	E_NAME		/* Illegal name */
} ERROR;

extern int short_help;
extern int file_loaded;
extern int merge_type;
extern int total_sec;
extern int total_usec;
extern int last_sec;
extern int last_usec;
extern ERROR SGM_ERROR;
extern char *infilename;

extern int exec_action_list(struct action_type *, int);
extern ERROR exec_action(struct action_type *, int);
extern int check_for_cond(int, struct action_type *);
extern int graphs_update(struct action_type *a, int i, struct thread_type **g0,
                  struct thread_type **g1, struct thread_type **g2);
extern int interactive_mode(void);
extern int cmd_str_to_int(char *cmd);
extern int get_graph_info(char *full_name, char **real_name, int *id);
extern struct action_type *cmd_to_action(int cmd, char **arg, int);
extern int get_gd_info(char *, char **, int *, int *);
extern ERROR exec_cmd(int cmd, char **arg, int);

extern ERROR load_file(char *);
extern ERROR read_spec(void);
extern char *print_size(struct thread_type *);
extern char *print_components(struct thread_type *);
extern char *print_mnpl(struct thread_type *);
extern char *print_time(struct thread_type *);
extern TOKEN gettoken(char *word);
extern int sgm_quit(void);
extern int gettime(int);
extern int verbosity_level(int);
extern int info_graph(struct thread_type *);
extern int short_info(struct thread_type *, int);
extern int reset_str(char *, int);
extern int is_invalid_char(char);
extern int rename_graph(struct thread_type *, char *);
#endif
