
define(e1,10)
define(e2,10)
define(e3,8)

define(p1,200)
define(p2,200)
define(p3,100)

define(d1,400)
define(d2,400)
define(d3,100)

automata A: i=1..3;
clock    x[1..total(A)];
clock    y[1..total(A)];
register p;
register c16, c27, c35;

--------------------------------------------------------------------------
automaton A[i] {
initially I and c16 = 0 & c27 = 0 & c35 = 0 and x[i] = 0;
  mode I{ 
    invariant True;
    when True may goto E; p := i;
  }
  mode E{ 
    invariant True;
    when p = 1 and x[i] = e1 may goto D; c16 := 1;
    when p = 2 and x[i] = e2 may goto D; c27 := 1;
    when p = 3 and x[i] = e3 may goto D; c35 := 1;
  }
  mode D{ 
    invariant True;
    when p = 1 and x[i] >= p1 may goto R; y[i] := 0;
    when p = 2 and x[i] >= p2 may goto R; y[i] := 0;
    when p = 3 and x[i] >= p3 may goto R; y[i] := 0;
  }
  mode R{
    invariant y[i] = 0;
    when p = 1 and x[i] > d1 may goto V;
    when p = 2 and x[i] > d2 may goto V;
    when p = 3 and x[i] > d3 may goto V;
    when p = 1 and x[i] <= d1 may goto I;
    when p = 2 and x[i] <= d2 may goto I;
    when p = 3 and x[i] <= d3 may goto I;
  }
  mode V{
    invariant True;
  }
}

--verify all_paths (henceforth not{(mode(A[1]) = M4) and (mode(A[2]) = M4)}
--                         and not{(mode(A[1]) = M4) and (mode(A[3]) = M4)}
--                         and not{(mode(A[2]) = M4) and (mode(A[3]) = M4)}
--                 );

manipulation

----------------------------------------
--   A user-defined sequential merge  --
----------------------------------------
--    graph g[1..3];
--
--    for(i:=1; i<4; i++) {
--      if(i = 1) {
--        g[1] := merge_graph(A[1], A[2]);
--      }
--      else {
--        g[i] := merge_graph(g[i-1], A[i+1]);
--      }
--    }
--    read_write(g[i-1]);
--    shield_clock(g[i-1]);
--    normalize_region(g[i-1]);
--
--    model_check(g[total_automata-1]);
--    print_graph(g[total_automata-1]);
----------------------------------------

----------------------------------------
--   System-defined sequential merge  --
----------------------------------------
    sequential_merge();
--    read_write();
--    shield_clock();
--    normalize_region();
--    transition_bypass();   -- No use
--    print_graph();
