
define(e1,10)
define(e2,10)
define(e3,8)

define(p1,200)
define(p2,200)
define(p3,100)

define(d1,400)
define(d2,400)
define(d3,100)

automata A1, A2, A3;
clock    x1, x2, x3;
clock    y1, y2, y3;
register c16, c27, c35;

--------------------------------------------------------------------------
automaton A1 {
initially I and c16 = 0 and x1 = 0;
  mode I{ 
    invariant True;
    when True may goto E;
  }
  mode E{ 
    invariant True;
    when x1 = e1 may goto D; c16 := 1;
  }
  mode D{ 
    invariant True;
    when x1 >= p1 may goto R; y1:=0;
  }
  mode R{
    invariant y1 = 0;
    when x1 > d1 may goto V;
    when x1 <= d1 may goto I;
  }
  mode V{
    invariant True;
  }
}

automaton A2 {
initially I and c27 = 0 and x2 = 0;
  mode I{ 
    invariant True;
    when True may goto E;
  }
  mode E{ 
    invariant True;
    when x2 = e2 may goto D; c27 := 1;
  }
  mode D{ 
    invariant True;
    when x2 >= p2 may goto R; y2:=0;
  }
  mode R{
    invariant y2 = 0;
    when x2 > d2 may goto V;
    when x2 <= d2 may goto I;
  }
  mode V{
    invariant True;
  }
}

automaton A3 {
initially I and c35 = 0 and x3 = 0;
  mode I{ 
    invariant True;
    when True may goto E;
  }
  mode E{ 
    invariant True;
    when x3 = e3 may goto D; c35 := 1;
  }
  mode D{ 
    invariant True;
    when x3 >= p3 may goto R; y3:=0;
  }
  mode R{
    invariant y3 = 0;
    when x3 > d3 may goto V;
    when x3 <= d3 may goto I;
  }
  mode V{
    invariant True;
  }
}

--verify all_paths (henceforth not{(mode(A[1]) = M4) and (mode(A[2]) = M4)}
--                         and not{(mode(A[1]) = M4) and (mode(A[3]) = M4)}
--                         and not{(mode(A[2]) = M4) and (mode(A[3]) = M4)}
--                 );

manipulation

----------------------------------------
--   A user-defined sequential merge  --
----------------------------------------
--    graph g[1..3];
--
--    for(i:=1; i<4; i++) {
--      if(i = 1) {
--        g[1] := merge_graph(A[1], A[2]);
--      }
--      else {
--        g[i] := merge_graph(g[i-1], A[i+1]);
--      }
--    }
--    read_write(g[i-1]);
--    shield_clock(g[i-1]);
--    normalize_region(g[i-1]);
--
--    model_check(g[total_automata-1]);
--    print_graph(g[total_automata-1]);
----------------------------------------

----------------------------------------
--   System-defined sequential merge  --
----------------------------------------
    sequential_merge();
--    read_write();
--    shield_clock();
--    normalize_region();
--    transition_bypass();   -- No use
--    print_graph();
