
define(e1,10)
define(e2,5)
define(e3,15)
define(e4,15)
define(e5,20)
define(e6,5)

define(p1,200)
define(p2,100)
define(p3,100)
define(p4,100)
define(p5,100)
define(p6,50)

define(d1,400)
define(d2,100)
define(d3,100)
define(d4,100)
define(d5,100)
define(d6,50)

automata A: i=1..6;
clock    x[1..total(A)];
clock    y[1..total(A)];
register p;
register c13, c23, c24, c25, c35, c36, c43, c45, c46;

--------------------------------------------------------------------------
automaton A[i] {
initially I and c13 = 0 & c23 = 0 & c24 = 0 & 
                c25 = 0 & c35 = 0 & c36 = 0 & 
                c43 = 0 & c45 = 0 & c46 = 0
            and x[i] = 0;
  mode I{ 
    invariant True;
    when True may goto E; p := i;
  }
  mode E{ 
    invariant True;
    when p = 1 and x[i] = e1 may goto D; c13 := 1;
    when p = 2 and x[i] = e2 may goto D; c23 := 1; c24 := 1; c25 := 1;
    when p = 3 and x[i] = e3 may goto D;
         c13 := 0; c23 := 0; c43 := 0; c35 := 1; c36 := 1;
    when p = 4 and x[i] = e4 may goto D;
         c24 := 0; c43 := 1; c45 := 1; c46 := 1;
    when p = 5 and x[i] = e5 may goto D; 
         c25 := 0; c35 := 0; c45 := 0;
    when p = 6 and x[i] = e6 may goto D; c36 := 0; c46 := 0;
  }
  mode D{ 
    invariant True;
    when p = 1 and x[i] >= p1 may goto R; y[i] := 0;
    when p = 2 and x[i] >= p2 may goto R; y[i] := 0;
    when p = 3 and x[i] >= p3 may goto R; y[i] := 0;
    when p = 4 and x[i] >= p4 may goto R; y[i] := 0;
    when p = 5 and x[i] >= p5 may goto R; y[i] := 0;
    when p = 6 and x[i] >= p6 may goto R; y[i] := 0;
  }
  mode R{
    invariant y[i] = 0;
    when p = 1 and x[i] > d1 may goto V;
    when p = 2 and x[i] > d2 may goto V;
    when p = 3 and x[i] > d3 may goto V;
    when p = 4 and x[i] > d4 may goto V;
    when p = 5 and x[i] > d5 may goto V;
    when p = 6 and x[i] > d6 may goto V;
    when p = 1 and x[i] <= d1 may goto I;
    when p = 2 and x[i] <= d2 may goto I;
    when p = 3 and x[i] <= d3 may goto I;
    when p = 4 and x[i] <= d4 may goto I;
    when p = 5 and x[i] <= d5 may goto I;
    when p = 6 and x[i] <= d6 may goto I;
  }
  mode V{
    invariant True;
  }
}

--verify all_paths (henceforth not{(mode(A[1]) = M4) and (mode(A[2]) = M4)}
--                         and not{(mode(A[1]) = M4) and (mode(A[3]) = M4)}
--                         and not{(mode(A[2]) = M4) and (mode(A[3]) = M4)}
--                 );

manipulation

----------------------------------------
--   A user-defined sequential merge  --
----------------------------------------
--    graph g[1..3];
--
--    for(i:=1; i<4; i++) {
--      if(i = 1) {
--        g[1] := merge_graph(A[1], A[2]);
--      }
--      else {
--        g[i] := merge_graph(g[i-1], A[i+1]);
--      }
--    }
--    read_write(g[i-1]);
--    shield_clock(g[i-1]);
--    normalize_region(g[i-1]);
--
--    model_check(g[total_automata-1]);
--    print_graph(g[total_automata-1]);
----------------------------------------

----------------------------------------
--   System-defined sequential merge  --
----------------------------------------
    sequential_merge();
--    read_write();
--    shield_clock();
--    normalize_region();
--    transition_bypass();   -- No use
--    print_graph();
