automata Client : i = 1..6;
clock x[1..total(Client)];
register lock, request;

--------------------------------------------------------------------------
automaton Client[i] {
initially Idle and lock = 0 & request = 0 and x[i] = 0;
  mode Idle { 
    invariant True;
    when lock = 0  & request = 0  may goto ROE; 
                                               lock := i; x[i] := 0;
    when lock = 0  & request != 0 may goto ROL; 
    when lock != 0 & request = 0  may goto RIE; request := i;
    when lock != 0 & request != 0 may goto RIL; 
  }
  mode ROE { 
    invariant x[i] <= 1;
    when x[i] = 1 may goto Granted;
  }
  mode ROL {
    invariant True;
    when lock != 0 & request = 0 may goto RIE; request := i;
  }
  mode RIE {
    invariant True;
    when lock = 0 & request = i may goto ROE; lock := i; request := 0; x[i]:=0;
  }
  mode RIL {
    invariant True;
    when lock = 0 & request != 0 may goto ROL;
  }
  mode Granted {
    invariant True;
    when True may goto Idle; lock := 0;
    when request = 0 may goto RIE; lock := 0; request := i;
    when request != 0 may goto ROL; lock := 0;
  }
}

manipulation
  sequential_merge();
  transition_bypass();
  shield_clock();
  normalize_region();
  read_write();
--    print_graph();
--    model_check();

