

automata A : i = 1..2, B : j = 3..4;
clock x[1..total(A)];
register lock, q1, q2;

--------------------------------------------------------------------------
automaton A[i] {
initially M1 and lock = 0 & q1 = 1 and x[i] = 0;
  mode M1 { 
    invariant True;
    when lock = 0 & q1 = i may goto M2; x[i] := 0;
  }
  mode M2{ 
    invariant q1 = i and x[i] < 1;
    when x[i] < 1 may goto M3; x[i] := 0; lock := i;
  }
  mode M3{ 
    invariant q1 = i;
    when x[i] >= 1 and lock = i may goto M4;
    when ~(lock = i) & q1 = 1 may goto M1; q1 := 2;
    when ~(lock = i) & q1 = 2 may goto M1; q1 := 1;
  }
  mode M4{
    invariant q1 = i;
    when q1 = 1 may goto M1; lock := 0; q1 := 2;
    when q1 = 2 may goto M1; lock := 0; q1 := 1;
  }
}

automaton B[j] {
initially M1 and lock = 0 & q2 = 3 and x[j] = 0;
  mode M1 { 
    invariant True;
    when lock = 0 & q2 = j may goto M2; x[j] := 0;
  }
  mode M2{ 
    invariant q2 = j and x[j] < 1;
    when x[j] < 1 may goto M3; x[j] := 0; lock := j;
  }
  mode M3{ 
    invariant q2 = j;
    when x[j] >= 1 and lock = j may goto M4;
    when ~(lock = j) & q2 = 3 may goto M1; q2 := 4;
    when ~(lock = j) & q2 = 4 may goto M1; q2 := 3;
  }
  mode M4{
    invariant q2 = j;
    when q2 = 3 may goto M1; lock := 0; q2 := 4;
    when q2 = 4 may goto M1; lock := 0; q2 := 3;
  }
}

--verify all_paths (henceforth not{(mode(A[1]) = M4) and (mode(A[2]) = M4)}
--                         and not{(mode(A[1]) = M4) and (mode(A[3]) = M4)}
--                         and not{(mode(A[2]) = M4) and (mode(A[3]) = M4)}
--                 );

manipulation

----------------------------------------
--   A user-defined sequential merge  --
----------------------------------------
--    graph g[1..total_automata-1];
--
--    for(i:=1; i<total_automata; i++) {
--      if(i = 1) {
--        g[1] := merge_graph(A[1], A[2]);
--      }
--      else {
--        g[i] := merge_graph(g[i-1], A[i+1]);
--      }
--      look_ahead(g[i-1], g[i]);
--      shield_clock(g[i]);
--      normalize_region(g[i]);
--    }
--    model_check(g[total_automata-1]);
--    print_graph(g[total_automata-1]);
----------------------------------------

----------------------------------------
--   System-defined sequential merge  --
----------------------------------------
    sequential_merge();
    read_write();
    shield_clock();
--    normalize_region();
--    transition_bypass();   -- No use
--    print_graph();
