
automata A : i = 1..4;
clock x[1..total(A)];
register lock, s1, s2, s3;

--------------------------------------------------------------------------
automaton A[i] {
initially M1 and lock = 0 & s1 = 1 and x[i] = 0;
  mode M1 { 
    invariant True;
    when s1 = i & s1 < 4 & lock = 0 may goto M2; x[i] := 0; s1 := i+1;
    when s1 = i & s1 = 4 & lock = 0 may goto M2; x[i] := 0; s1 := 1;
  }
  mode M2{ 
    invariant x[i] < 1;
    when s2 = i & s2 < 4 and x[i] < 1 may goto M3; 
                                       x[i] := 0; lock := i; s2 := i+1;
    when s2 = i & s2 = 4 and x[i] < 1 may goto M3; 
                                       x[i] := 0; lock := i; s2 := 1;
  }
  mode M3{ 
    invariant True;
    when x[i] >= 1 and lock = i & s3 = i & s3 < 4 may goto M4; s3 := i+1;
    when x[i] >= 1 and lock = i & s3 = i & s3 = 4 may goto M4; s3 := 1;
    when ~(lock = i) & s3 = i & s3 < 4 may goto M1; s3 := i+1;
    when ~(lock = i) & s3 = i & s3 = 4 may goto M1; s3 := 1;
  }
  mode M4{
    invariant True;
    when True may goto M1; lock := 0;
  }
}

--verify all_paths (henceforth not{(mode(A[1]) = M4) and (mode(A[2]) = M4)}
--                         and not{(mode(A[1]) = M4) and (mode(A[3]) = M4)}
--                         and not{(mode(A[2]) = M4) and (mode(A[3]) = M4)}
--                 );

manipulation

----------------------------------------
--   A user-defined sequential merge  --
----------------------------------------
--    graph g[1..total_automata-1];
--
--    for(i:=1; i<total_automata; i++) {
--      if(i = 1) {
--        g[1] := merge_graph(A[1], A[2]);
--      }
--      else {
--        g[i] := merge_graph(g[i-1], A[i+1]);
--      }
--      look_ahead(g[i-1], g[i]);
--      shield_clock(g[i]);
--      normalize_region(g[i]);
--    }
--    model_check(g[total_automata-1]);
--    print_graph(g[total_automata-1]);
----------------------------------------

----------------------------------------
--   System-defined sequential merge  --
----------------------------------------
    sequential_merge();
    read_write();
    shield_clock();
    normalize_region();
--    transition_bypass();   -- No use
--    print_graph();
