define(TA,4)
automata A : i = 1, B : j = 2, C : k = 3, D : l = 4;
clock x[1..total(A)];
register lock, s1, m1, m2, m3, m4;

--------------------------------------------------------------------------
automaton A[i] {
initially M1 and lock = 0 & s1 = 1 & m1 = 0 and x[i] = 0;
  mode M1 {
    invariant True;
    when lock = 0 may goto M2; x[i] := 0; m1 := 1;
  }
  mode M2{ 
    invariant x[i] < 1;
    when m2 = 0 & m3 = 0 & m4 = 0 and x[i] < 1 may goto M3;
                                      x[i] := 0; lock := i; m1 := 0;
    when s1 = i & m2 = 1 and x[i] < 1 may goto M3; 
                                      x[i] := 0; lock := i; s1 := i+1; m1 := 0;
    when s1 = i & m3 = 1 & m2 = 0 and x[i] < 1 may goto M3;
                                      x[i] := 0; lock := i; s1 := 3; m1 := 0;
    when s1 = i & m4 = 1 & m3 = 0 & m2 = 0 and x[i] < 1 may goto M3; 
                                      x[i] := 0; lock := i; s1 := 4; m1 := 0;
  }
  mode M3{ 
    invariant True;
    when x[i] >= 1 and lock = i may goto M4;
    when ~(lock = i) may goto M1;
  }
  mode M4{
    invariant True;
    when True may goto M1; lock := 0;
  }
}

automaton B[j] {
initially M1 and lock = 0 & s1 = 1 & m2 = 0 and x[j] = 0;
  mode M1 {
    invariant True;
    when lock = 0 may goto M2; x[j] := 0; m2 := 1;
  }
  mode M2{ 
    invariant x[j] < 1;
    when m1 = 0 & m3 = 0 & m4 = 0 and x[j] < 1 may goto M3;
                                      x[j] := 0; lock := j; m2 := 0;
    when s1 = j & m3 = 1 and x[j] < 1 may goto M3; 
                                      x[j] := 0; lock := j; s1 := 3; m2 := 0;
    when s1 = j & m4 = 1 & m3 = 0 and x[j] < 1 may goto M3;
                                      x[j] := 0; lock := j; s1 := 4; m2 := 0;
  }
  mode M3{ 
    invariant True;
    when x[j] >= 1 and lock = j may goto M4;
    when ~(lock = j) may goto M1;
  }
  mode M4{
    invariant True;
    when True may goto M1; lock := 0;
  }
}

automaton C[k] {
initially M1 and lock = 0 & s1 = 1 & m3 = 0 and x[k] = 0;
  mode M1 {
    invariant True;
    when lock = 0 may goto M2; x[k] := 0; m3 := 1;
  }
  mode M2{ 
    invariant x[k] < 1;
    when m1 = 0 & m2 = 0 & m4 = 0 and x[k] < 1 may goto M3;
                                      x[k] := 0; lock := k; m3 := 0;
    when s1 = k & m4 = 1 and x[k] < 1 may goto M3; 
                                      x[k] := 0; lock := k; s1 := 4; m3 := 0;
  }
  mode M3{ 
    invariant True;
    when x[k] >= 1 and lock = k may goto M4;
    when ~(lock = k) may goto M1;
  }
  mode M4{
    invariant True;
    when True may goto M1; lock := 0;
  }
}

automaton D[l] {
initially M1 and lock = 0 & s1 = 1 & m4 = 0 and x[l] = 0;
  mode M1 {
    invariant True;
    when lock = 0 may goto M2; x[l] := 0; m4 := 1;
  }
  mode M2{ 
    invariant x[l] < 1;
    when m1 = 0 & m2 = 0 & m3 = 0 and x[l] < 1 may goto M3;
                                      x[l] := 0; lock := l; m4 := 0;
    when s1 = l and x[l] < 1 may goto M3; 
                                      x[l] := 0; lock := l; s1 := 1; m4 := 0;
  }
  mode M3{ 
    invariant True;
    when x[l] >= 1 and lock = l may goto M4;
    when ~(lock = l) may goto M1;
  }
  mode M4{
    invariant True;
    when True may goto M1; lock := 0;
  }
}

--verify all_paths (henceforth not{(mode(A[1]) = M4) and (mode(A[2]) = M4)}
--                         and not{(mode(A[1]) = M4) and (mode(A[3]) = M4)}
--                         and not{(mode(A[2]) = M4) and (mode(A[3]) = M4)}
--                 );

manipulation

----------------------------------------
--   A user-defined sequential merge  --
----------------------------------------
--    graph g[1..total_automata-1];
--
--    for(i:=1; i<total_automata; i++) {
--      if(i = 1) {
--        g[1] := merge_graph(A[1], A[2]);
--      }
--      else {
--        g[i] := merge_graph(g[i-1], A[i+1]);
--      }
--      look_ahead(g[i-1], g[i]);
--      shield_clock(g[i]);
--      normalize_region(g[i]);
--    }
--    model_check(g[total_automata-1]);
--    print_graph(g[total_automata-1]);
----------------------------------------

----------------------------------------
--   System-defined sequential merge  --
----------------------------------------
    sequential_merge();
    read_write();
    shield_clock();
    normalize_region();
--    transition_bypass();   -- No use
--    print_graph();
