define(TA,4)
define(TC,6)
automata S : i = 1..TA;
clock x[1..TA];
register lock, Count;

--------------------------------------------------------------------------
automaton S[i] {
initially Init and lock = 1 & Count = 5 and x[i] = 0;
  mode Init { 
    invariant True;
    when lock = i may goto Poll; x[i] := 0;
  }
  mode Poll{ 
    invariant lock = i and x[i] <= 1;
    when Count > 0 and x[i] = 1 may goto CarIn; x[i] := 0;
    when Count < 5 and x[i] = 1 may goto CarOut; x[i] := 0;
    when x[i] = 1 may goto Check; x[i] := 0;
  }
  mode CarIn{ 
    invariant lock = i and x[i] <= 1;
    when lock < TA and x[i] = 1 may goto Init; Count := Count - 1 (mod TC);
                                               lock := i + 1;
                                               x[i] := 0;
    when lock = TA and x[i] = 1 may goto Init; Count := Count - 1 (mod TC);
                                               lock := 1;
                                               x[i] := 0;
  }
  mode CarOut{
    invariant lock = i and x[i] <= 1;
    when lock < TA and x[i] = 1 may goto Init; Count := Count + 1 (mod TC); 
                                               lock := i + 1;
                                               x[i] := 0;
    when lock = TA and x[i] = 1 may goto Init; Count := Count + 1 (mod TC); 
                                               lock := 1;
                                               x[i] := 0;
  }
  mode Check{
    invariant lock = i and x[i] < 1;
    when lock < TA and x[i] < 1 may goto Init; lock := i + 1;
                                               x[i] := 0;
    when lock = TA and x[i] < 1 may goto Init; lock := 1;
                                               x[i] := 0;
  }
}

--verify all_paths (henceforth not{(mode(A[1]) = M4) and (mode(A[2]) = M4)}
--                         and not{(mode(A[1]) = M4) and (mode(A[3]) = M4)}
--                         and not{(mode(A[2]) = M4) and (mode(A[3]) = M4)}
--                 );

manipulation

----------------------------------------
--   A user-defined sequential merge  --
----------------------------------------
--    graph g[1..total_automata-1];
--
--    for(i:=1; i<total_automata; i++) {
--      if(i = 1) {
--        g[1] := merge_graph(A[1], A[2]);
--      }
--      else {
--        g[i] := merge_graph(g[i-1], A[i+1]);
--      }
--      look_ahead(g[i-1], g[i]);
--      shield_clock(g[i]);
--      normalize_region(g[i]);
--    }
--    model_check(g[total_automata-1]);
--    print_graph(g[total_automata-1]);
----------------------------------------

----------------------------------------
--   System-defined sequential merge  --
----------------------------------------
    sequential_merge();
    read_write();
    shield_clock();
--    normalize_region();
--    transition_bypass();   -- No use
--    print_graph();
