


automata P : i = 1..2, Q : j = 3..4;
clock x[1..2], y[1..2];
register lock1, lock2, Count;

--------------------------------------------------------------------------
automaton P[i] {
initially Init and lock1 = 1 & Count = 5 and x[i] = 0;
  mode Init { 
    invariant True;
    when lock1 = i may goto Poll; x[i] := 0;
  }
  mode Poll{ 
    invariant lock1 = i and x[i] <= 1;
    when Count > 0 and x[i] = 1 may goto CarIn; x[i] := 0;
    when Count < 5 and x[i] = 1 may goto CarOut; x[i] := 0;
    when x[i] = 1 may goto Check; x[i] := 0;
  }
  mode CarIn{ 
    invariant lock1 = i and x[i] <= 1;
    when lock1 = 1 and x[i] = 1 may goto Init; Count := Count - 1 (mod 6);
                                                lock1 := 2;
                                                x[i] := 0;
    when lock1 = 2 and x[i] = 1 may goto Init; Count := Count - 1 (mod 6);
                                                lock1 := 1;
                                                x[i] := 0;
  }
  mode CarOut{
    invariant lock1 = i and x[i] <= 1;
    when lock1 = 1 and x[i] = 1 may goto Init; Count := Count + 1 (mod 6); 
                                                lock1 := 2;
                                                x[i] := 0;
    when lock1 = 2 and x[i] = 1 may goto Init; Count := Count + 1 (mod 6); 
                                                lock1 := 1;
                                                x[i] := 0;
  }
  mode Check{
    invariant lock1 = i and x[i] < 1;
    when lock1 = 1 and x[i] < 1 may goto Init; lock1 := 2;
                                               x[i] := 0;
    when lock1 = 2 and x[i] < 1 may goto Init; lock1 := 1;
                                               x[i] := 0;
  }
}

--------------------------------------------------------------------------
automaton Q[j] {
initially Init and lock2 = 3 & Count = 5 and y[j] = 0;
  mode Init { 
    invariant True;
    when lock2 = j may goto Poll; y[j] := 0;
  }
  mode Poll{ 
    invariant lock2 = j and y[j] <= 1;
    when Count > 0 and y[j] = 1 may goto CarIn; y[j] := 0;
    when Count < 5 and y[j] = 1 may goto CarOut; y[j] := 0;
    when y[j] = 1 may goto Check; y[j] := 0;
  }
  mode CarIn{ 
    invariant lock2 = j and y[j] <= 1;
    when lock2 = 3 and y[j] = 1 may goto Init; Count := Count - 1 (mod 6);
                                               lock2 := 4;
                                               y[j] := 0;
    when lock2 = 4 and y[j] = 1 may goto Init; Count := Count - 1 (mod 6);
                                               lock2 := 3;
                                               y[j] := 0;
  }
  mode CarOut{
    invariant lock2 = j and y[j] <= 1;
    when lock2 = 3 and y[j] = 1 may goto Init; Count := Count + 1 (mod 6); 
                                               lock2 := 4;
                                               y[j] := 0;
    when lock2 = 4 and y[j] = 1 may goto Init; Count := Count + 1 (mod 6); 
                                               lock2 := 3;
                                               y[j] := 0;
  }
  mode Check{
    invariant lock2 = j and y[j] < 1;
    when lock2 = 3 and y[j] < 1 may goto Init; lock2 := 4;
                                               y[j] := 0;
    when lock2 = 4 and y[j] < 1 may goto Init; lock2 := 3;
                                               y[j] := 0;
  }
}

manipulation
--    graph g[1..3];
--
--    g[1] := merge_graph(P[1], P[2]);
--    read_write(g[1]);
--    shield_clock(g[1]);
--    normalize_region(g[1]);
--    g[2] := merge_graph(Q[3], Q[4]);
--    read_write(g[2]);
--    shield_clock(g[2]);
--    normalize_region(g[2]);
--    g[3] := merge_graph(g[1], g[2]);
--    read_write(g[3]);
--    shield_clock(g[3]);
--    normalize_region(g[3]);

----------------------------------------
--   System-defined sequential merge  --
----------------------------------------
    sequential_merge();
    read_write();
    shield_clock();
--    normalize_region();
--    transition_bypass();   -- No use
--    print_graph();
