define(TA,4)
define(TA1,3)
define(TC,6)
automata S : i = 1..TA;
clock x[1..TA];
register lock1, lock2, Count;

--------------------------------------------------------------------------
automaton S[i] {
initially Init and lock1 = 1 & lock2 = 3 & Count = 5 and x[i] = 0;
  mode Init { 
    invariant True;
    when lock1 = i may goto Poll; x[i] := 0;
    when lock2 = i may goto Poll; x[i] := 0;
  }
  mode Poll{ 
    invariant x[i] <= 1;
    when Count > 0 and x[i] = 1 may goto CarIn; x[i] := 0;
    when Count < 5 and x[i] = 1 may goto CarOut; x[i] := 0;
    when x[i] = 1 may goto Check; x[i] := 0;
  }
  mode CarIn{ 
    invariant x[i] <= 1;
    when lock1 = 1 and x[i] = 1 may goto Init; Count := Count - 1 (mod TC);
                                                lock1 := 2;
                                                x[i] := 0;
    when lock1 = 2 and x[i] = 1 may goto Init; Count := Count - 1 (mod TC);
                                                lock1 := 1;
                                                x[i] := 0;
    when lock2 = 3 and x[i] = 1 may goto Init; Count := Count - 1 (mod TC);
                                               lock2 := 4;
                                               x[i] := 0;
    when lock2 = 4 and x[i] = 1 may goto Init; Count := Count - 1 (mod TC);
                                               lock2 := 3;
                                               x[i] := 0;
  }
  mode CarOut{
    invariant x[i] <= 1;
    when lock1 = 1 and x[i] = 1 may goto Init; Count := Count + 1 (mod TC); 
                                                lock1 := 2;
                                                x[i] := 0;
    when lock1 = 2 and x[i] = 1 may goto Init; Count := Count + 1 (mod TC); 
                                                lock1 := 1;
                                                x[i] := 0;
    when lock2 = 3 and x[i] = 1 may goto Init; Count := Count + 1 (mod TC); 
                                               lock2 := 4;
                                               x[i] := 0;
    when lock2 = 4 and x[i] = 1 may goto Init; Count := Count + 1 (mod TC); 
                                               lock2 := 3;
                                               x[i] := 0;
  }
  mode Check{
    invariant x[i] < 1;
    when lock1 = 1 and x[i] < 1 may goto Init; lock1 := 2;
                                               x[i] := 0;
    when lock1 = 2 and x[i] < 1 may goto Init; lock1 := 1;
                                               x[i] := 0;
    when lock2 = 3 and x[i] < 1 may goto Init; lock2 := 4;
                                               x[i] := 0;
    when lock2 = 4 and x[i] < 1 may goto Init; lock2 := 3;
                                               x[i] := 0;
  }
}

manipulation
----------------------------------------
--   System-defined sequential merge  --
----------------------------------------
    sequential_merge();
    read_write();
    shield_clock();
--    normalize_region();
--    transition_bypass();   -- No use
--    print_graph();
