define(TA,4)
define(TC,6)
automata P : i = 1..TA;
clock x[1..TA];
register Count;

--------------------------------------------------------------------------
automaton P[i] {
initially Init and Count = 5 and x[i] = 0;
  mode Init { 
    invariant True;
    when True may goto Poll; x[i] := 0;
  }
  mode Poll{ 
    invariant x[i] <= 1;
    when Count > 0 and x[i] = 1 may goto CarIn; x[i] := 0;
    when Count < 5 and x[i] = 1 may goto CarOut; x[i] := 0;
    when x[i] = 1 may goto Check; x[i] := 0;
  }
  mode CarIn{ 
    invariant x[i] <= 1;
    when x[i] = 1 may goto Init; Count := Count - 1 (mod TC);
                                                x[i] := 0;
  }
  mode CarOut{
    invariant x[i] <= 1;
    when x[i] = 1 may goto Init; Count := Count + 1 (mod TC); 
                                 x[i] := 0;
  }
  mode Check{
    invariant x[i] < 1;
    when x[i] < 1 may goto Init; x[i] := 0;
  }
}

manipulation
----------------------------------------
--   System-defined sequential merge  --
----------------------------------------
    sequential_merge();
    read_write();
    shield_clock();
--    normalize_region();
--    transition_bypass();   -- No use
--    print_graph();
