

automata P : i = 1..4;
clock x[1..4];
register s1, s2, Count;

--------------------------------------------------------------------------
automaton P[i] {
initially Init and s1 = 1 & s2 = 1 & Count = 5 and x[i] = 0;
  mode Init { 
    invariant True;
    when s1 = i & s1 < 4 may goto Poll; x[i] := 0; s1 := i + 1;
    when s1 = i & s1 = 4 may goto Poll; x[i] := 0; s1 := 1;
  }
  mode Poll{ 
    invariant x[i] <= 1;
    when s2 = i & s2 < 4 & Count > 0 and x[i] = 1 may goto CarIn; 
                                                   x[i] := 0; s2 := i + 1;
    when s2 = i & s2 = 4 & Count > 0 and x[i] = 1 may goto CarIn; 
                                                   x[i] := 0; s2 := 1;
    when s2 = i & s2 < 4 & Count < 5 and x[i] = 1 may goto CarOut; 
                                                   x[i] := 0; s2 := i + 1;
    when s2 = i & s2 = 4 & Count < 5 and x[i] = 1 may goto CarOut; 
                                                   x[i] := 0; s2 := 1;
    when s2 = i & s2 < 4 & x[i] = 1 may goto Check; x[i] := 0; s2 := i + 1;
    when s2 = i & s2 = 4 & x[i] = 1 may goto Check; x[i] := 0; s2 := 1;
  }
  mode CarIn{ 
    invariant x[i] <= 1;
    when x[i] = 1 may goto Init; Count := Count - 1 (mod 6);
                                 x[i] := 0;
  }
  mode CarOut{
    invariant x[i] <= 1;
    when x[i] = 1 may goto Init; Count := Count + 1 (mod 6); 
                                 x[i] := 0;
  }
  mode Check{
    invariant x[i] < 1;
    when x[i] < 1 may goto Init; x[i] := 0;
  }
}

manipulation
----------------------------------------
--   System-defined sequential merge  --
----------------------------------------
    sequential_merge();
    read_write();
    shield_clock();
--    normalize_region();
--    transition_bypass();   -- No use
--    print_graph();
