define(TA,4)
define(TC,6)
automata P : i = 1..TA;
clock x[1..TA];
register s2, Count;

--------------------------------------------------------------------------
automaton P[i] {
initially Init and s2 = 1 & Count = 5 and x[i] = 0;
  mode Init { 
    invariant True;
    when True may goto Poll; x[i] := 0;
  }
  mode Poll{ 
    invariant x[i] <= 1;
    when s2 = i & s2 < TA & Count > 0 and x[i] = 1 may goto CarIn; 
                                                   x[i] := 0; s2 := i + 1;
    when s2 = i & s2 = TA & Count > 0 and x[i] = 1 may goto CarIn; 
                                                   x[i] := 0; s2 := 1;
    when s2 = i & s2 < TA & Count < 5 and x[i] = 1 may goto CarOut; 
                                                   x[i] := 0; s2 := i + 1;
    when s2 = i & s2 = TA & Count < 5 and x[i] = 1 may goto CarOut; 
                                                   x[i] := 0; s2 := 1;
    when s2 = i & s2 < TA & x[i] = 1 may goto Check; x[i] := 0; s2 := i + 1;
    when s2 = i & s2 = TA & x[i] = 1 may goto Check; x[i] := 0; s2 := 1;
  }
  mode CarIn{ 
    invariant x[i] <= 1;
    when x[i] = 1 may goto Init; Count := Count - 1 (mod TC);
                                 x[i] := 0;
  }
  mode CarOut{
    invariant x[i] <= 1;
    when x[i] = 1 may goto Init; Count := Count + 1 (mod TC); 
                                 x[i] := 0;
  }
  mode Check{
    invariant x[i] < 1;
    when x[i] < 1 may goto Init; x[i] := 0;
  }
}

manipulation
----------------------------------------
--   System-defined sequential merge  --
----------------------------------------
    sequential_merge();
    read_write();
    shield_clock();
--    normalize_region();
--    transition_bypass();   -- No use
--    print_graph();
