automata Sender : i = 1..4;
clock x[1..total(Sender)];
register channel, user;

--------------------------------------------------------------------------
automaton Sender[i] {
initially Idle and 
          channel = 0 &      --  channel=0 => free, channel=1 =>in_use
          user = 0 and       --  user => last user index
          x[i] = 0;          --  x[i] => local clock
  mode Idle {
    invariant True;
    when channel = 0 may goto Ready; x[i] := 0;
  }
  mode Ready{
    invariant x[i] <= 1;
    when x[i] = 1 and channel = 1            may goto Collision; 
                                             x[i] := 0;
    when x[i] = 1 and user != 0              may goto Collision; 
                                             x[i] := 0; user := 0;
    when x[i] = 1 and user = 0 & channel = 0 may goto Transmit; 
                                             x[i] := 0; user := i;
  }
  mode Collision{
    invariant x[i] <= 2;
    when x[i] <= 2 and channel = 0 may goto Ready; x[i] := 0;
    when channel = 1 may goto Collision; x[i] := 0;
  }
  mode Transmit{
    invariant x[i] <= 2;
    when x[i] <= 2 and user != i may goto Collision; x[i] := 0; user := 0;
    when x[i] = 2 and user = i & channel = 0 may goto Safe_Transmit; 
                                                      channel := 1;
  }
  mode Safe_Transmit{
    invariant True;
    when x[i] > 2 and user = i & channel = 1 may goto Idle; 
                                         user := 0; channel := 0; x[i] := 0;
  }
}


--verify all_paths ( not {(~(lock = i) and x[i] <= 1) or (lock = 3)}  
--                   and (mode(A[1]) != M1)
--                  until >= 1
--                   {(mode(A[2]) != M3) or (mode(A[1]) = M1)}
--                   and (mode(A[2]) = M3)
--                 )
--       and exists_path (eventually {
--                         (henceforth not {(mode(A[1]) = M4) and 
--                                          (mode(A[2]) = M4)})
--                                   })
--;

--verify all_paths (henceforth not{(mode(A[1]) = M4) and (mode(A[2]) = M4)}
--                         and not{(mode(A[1]) = M4) and (mode(A[3]) = M4)}
--                         and not{(mode(A[2]) = M4) and (mode(A[3]) = M4)}
--                 );

--verify ~(mode(A[1]) = M4 and 
--         ~(mode(A[2]) = M4 or (mode(A[1]) = M3 or mode(A[1])=M4) and
--           mode(A[2]) = M2
--          )
--         or mode(A[2]) = M1
--        )
--        and 
--        (mode(A[2]) != M1) or 
--       ~(mode(A[1]) = M3 or mode(A[2]) = M3);


manipulation

----------------------------------------
--   A user-defined sequential merge  --
----------------------------------------
--    graph g[1..total_automata-1], g[1];
--
--    for(i:=1; i<total_automata; i++) {
--      if(i = 1) {
--        g[1] := merge_graph(A[1], A[2]);
--      }
--      else {
--        g[i] := merge_graph(g[i-1], A[i+1]);
--      }
--      look_ahead(g[i-1], g[i]);
--      shield_clock(g[i]);
--      normalize_region(g[i]);
--    }
--    model_check(g[total_automata-1]);
--    print_graph(g[total_automata-1]);
----------------------------------------

----------------------------------------
--   System-defined sequential merge  --
----------------------------------------
--
    sequential_merge();
    shield_clock();
    read_write();
    normalize_region();
--    hide_variables();
--    transition_bypass();
--
--    pairwise_merge();
--    look_ahead();
--    print_graph();
--    model_check();
----------------------------------------

----------------------------------------
--    if(num_modes(g[1]) < num_modes(g[2])) {
--      model_check(g[1]);
--    }
--    if(num_trans(g[2]) < num_trans(A[1])) {
--      model_check(A[1]);
--    }

--  graph gg, y2, x3, g[1..total_automata-1];
--    for(i:=0; i<total_automata; i++) {
--      if(i=1) {
--       g[1] := merge_graph(A[1], A[2]);
--        look_ahead(g[2], x3);
--        if(i <= 3) {
--          look_ahead(g[2], x3);
--        }
--      }
--      else {
--        x3 = merge_graph(A[1], A[3]);
--        look_ahead();
--        look_ahead(g[1], A[3]);
--      }
--    }
--    for(i:=0; i<total_automata; i++) {
--      g[2] := merge_graph(g[1], y2);
--      for(i=0; i<total_automata; i++) {
--        g[2] := merge_graph(g[1], y2);
--        look_ahead(A[3], y2);
--      }
--      look_ahead(A[3], y2);
--    }
--    look_ahead(A[1], A[3]);
--    model_check(g[2]);
