







automata S, R, SR, RS, U;
register msg, sendseq, rack, recseq, lack, 
         sc_pty, sc_pno, cs_pty, cs_pno, cs_ack,
         rc_pty, rc_pno, rc_ack, cr_pty, cr_pno, cr_ack,
         resnd_pno,
         cs_hck, cs_dck, cr_hck, cr_dck,
         sc_ctl, sc_ack, cs_ctl, rc_ctl, cr_ctl;

automaton S {
initially S_Idle and sendseq = 1 & rack = 0 & lack = 0 & recseq = 0 &
          sc_ctl = 3 & cr_ctl = 3 & rc_ctl = 3 & cs_ctl = 3 &
          sc_pno = 0 & cs_pno = 0 & rc_pno = 0 & cr_pno = 0 &
          resnd_pno = 0 & cs_ack = 0 & cr_ack = 0 & rc_ack = 0 & 
          sc_pty = 0 & sc_ack = 0 & cs_pty = 0 & rc_pty = 0 & 
          cr_pty = 0;
  mode S_Idle {
    invariant True;
    when msg = 1 may goto S_Ready;
    when cs_ctl = 4 may goto S_GetPkt;
  }
  mode S_Ready {
    invariant True;
    when sendseq - rack <= 1 (mod 2) & sendseq != rack (mod 2) 
              may goto S_Giving; 
              sc_pty:=0; sc_pno:=sendseq; sendseq:=sendseq+1 (mod 2);
    when sendseq - rack > 1 (mod 2) may goto S_OutOfWindow;
    when sendseq = rack (mod 2) may goto S_OutOfWindow;
  }
  mode S_Giving {
    invariant True;
    when sc_ctl = 3 may goto S_Idle;
                      lack:=recseq; sc_ctl:=4; msg:=0;
  }
  mode S_OutOfWindow {
    invariant True;
    when True may goto S_TimeOut;
    when cs_ctl = 4 may goto S_GetPkt;
  }
  mode S_TimeOut {
    invariant True;
    when cs_ctl = 4 may goto S_GetPkt;
  }
  mode S_GetPkt {
    invariant True;
    when cs_ctl = 4 & cs_hck = 1 & cs_pty = 1 & cs_ack != sendseq &
         sendseq - cs_ack <= 1 (mod 2) & cs_ack - rack <= 1 (mod 2)
         may goto S_GetPkt;
         rack := cs_ack; cs_ctl := 3;
    when cs_pty != 1 & cs_pty != 2 may goto S_Idle;
    when cs_hck = 1 & cs_pty = 2 & cs_pno != sendseq & 
         sendseq - cs_pno <= 1 (mod 2) & cs_pno - rack <= 1 (mod 2)
         may goto S_ResndNakdPkt;
         resnd_pno := cs_pno;
  }
  mode S_ResndNakdPkt {
    invariant True;
    when sc_ctl = 3 may goto S_Idle;
                      sc_pty := 0; sc_pno := resnd_pno; sc_ack := recseq;
                      sc_ctl := 4;
  }
}

automaton R {
initially R_Idle and cr_hck = 1 & cr_dck = 1 & 
                     sendseq = 1 & recseq = 0 & lack = 0 &
                     sc_ctl = 3 & cr_ctl = 3 & rc_ctl = 3 & cs_ctl = 3 &
                     sc_pno = 0 & cs_pno = 0 & rc_pno = 0 & cr_pno = 0 &
                     cs_ack = 0 & cr_ack = 0 & rc_ack = 0 &
                  sc_pty = 0 & cs_pty = 0 & rc_pty = 0 & cr_pty = 0;
  mode R_Idle {
    invariant True;
    when cr_ctl = 4 & cr_hck = 1 may goto R_GetPkt; cr_ctl := 3;
  }
  mode R_GetPkt {
    invariant True;
    when cr_pty = 2 may goto R_BugFix;
    when cr_pty = 0 & cr_pno != lack & cr_pno - lack <= 1 (mod 2)
                      may goto R_GetData;
    when cr_pty = 1 may goto R_Idle;
    when cr_pno = lack may goto R_Idle;
    when cr_pno - lack > 1 (mod 2) may goto R_Idle;
  }
  mode R_BugFix {
    invariant True;
    when rc_ctl = 3 may goto R_Idle; 
                lack := recseq; rc_ack := recseq;
		rc_pty := 1; rc_pno := recseq; rc_ctl := 4;
  }
  mode R_GetData {
    invariant True;
    when True may goto R_Idle;
  }
}

automaton SR {
initially SR_Getting and sc_ctl = 3 & cr_ctl = 3;
  mode SR_Getting {
    invariant True;
    when sc_ctl = 4 & cr_ctl = 3 may goto SR_Giving;
         cr_ctl := 4; sc_ctl := 3;
         cr_pty := sc_pty; cr_pno := sc_pno;
  }
  mode SR_Giving {
    invariant True;
    when True may goto SR_Getting;
  }
}

automaton RS {
initially RS_Getting and rc_ctl = 3 & cs_ctl = 3;
  mode RS_Getting {
    invariant True;
    when rc_ctl = 4 & cs_ctl = 3 may goto RS_Giving;
         rc_ctl := 3; cs_ctl := 4; cs_pty := rc_pty;
         cs_pno := rc_pno; cs_ack := rc_ack;
  }
  mode RS_Giving {
    invariant True;
    when True may goto RS_Getting;
  }
}

automaton U {
initially U_Snd and msg = 0;
  mode U_Snd {
    invariant True;
    when msg = 0 may goto U_Rcv; msg := 1;
    when msg = 0 may goto U_Rcv;
  }
  mode U_Rcv {
    invariant True;
    when True may goto U_Snd;
  }
}

manipulation
    sequential_merge();
    read_write();
--    shield_variables();
