define(INITIAL,0)
define(ZERO,0)
define(NON_ZERO,10)
define(ADD,11)
define(SUB,12)
define(MUL,13)
define(DIV,14)
define(EQ,15)
define(CE,16)
define(INPUT,17)

automata R1, R2, R3, R4, R5, R6, R7, R8, R9, R10, R11;

register value, op, vc, click;

--------------------------------------------------------------------------
automaton R1 {
initially M1 and value = INITIAL & op = INITIAL & vc = ZERO;
  mode M1 { 
    invariant True;
    when click = ZERO & value = INITIAL may goto M1; value := INPUT;
    when click = NON_ZERO & value = INITIAL may goto M1; value := INPUT; 
                                                         vc:=NON_ZERO;
    when click = ZERO & value = INPUT may goto M1; value := INPUT;
    when click = NON_ZERO & value = INPUT may goto M1; value := INPUT; 
                                                         vc:=NON_ZERO;
  }
}

automaton R2 {
initially M2 and value = INITIAL & op = INITIAL & vc = ZERO;
  mode M2 { 
    invariant True;
    when click = ZERO & value = ADD may goto M2; value := INPUT; vc := ZERO;
    when click = NON_ZERO & value = ADD may goto M2; value := INPUT; vc := ZERO;
    when click = ZERO & value = SUB may goto M2; value := INPUT; vc := ZERO;
    when click = NON_ZERO & value = SUB may goto M2; value := INPUT; vc := ZERO;
    when click = ZERO & value = MUL may goto M2; value := INPUT; vc := ZERO;
    when click = NON_ZERO & value = MUL may goto M2; value := INPUT; vc := ZERO;
    when click = ZERO & value = DIV may goto M2; value := INPUT; vc := ZERO;
    when click = NON_ZERO & value = DIV may goto M2; value := INPUT; vc := ZERO;
  }
}

automaton R3 {
initially M3 and value = INITIAL & op = INITIAL & vc = ZERO;
  mode M3 { 
    invariant True;
    when click = CE may goto M3; value := INITIAL; op := INITIAL; vc := ZERO;
  }
}

automaton R4 {
initially M4 and value = INITIAL & op = INITIAL & vc = ZERO;
  mode M4 { 
    invariant True;
    when click = ADD & value = INPUT may goto M4; vc := ZERO; op := ADD;
  }
}

automaton R5 {
initially M5 and value = INITIAL & op = INITIAL & vc = ZERO;
  mode M5 { 
    invariant True;
    when click = SUB & value = INPUT may goto M5; vc := ZERO; op := SUB;
  }
}

automaton R6 {
initially M6 and value = INITIAL & op = INITIAL & vc = ZERO;
  mode M6 { 
    invariant True;
    when click = MUL & value = INPUT may goto M6; vc := ZERO; op := MUL;
  }
}

automaton R7 {
initially M7 and value = INITIAL & op = INITIAL & vc = ZERO;
  mode M7 { 
    invariant True;
    when click = DIV & value = INPUT may goto M7; vc := ZERO; op := DIV;
  }
}

automaton R8 {
initially M8 and value = INITIAL & op = INITIAL & vc = ZERO;
  mode M8 { 
    invariant True;
    when click = EQ & op = ADD may goto M8; value := ADD; op := INITIAL;
  }
}

automaton R9 {
initially M9 and value = INITIAL & op = INITIAL & vc = ZERO;
  mode M9 { 
    invariant True;
    when click = EQ & op = SUB may goto M9; value := SUB; op := INITIAL;
  }
}

automaton R10 {
initially M10 and value = INITIAL & op = INITIAL & vc = ZERO;
  mode M10 { 
    invariant True;
    when click = EQ & op = MUL may goto M10; value := MUL; op := INITIAL;
  }
}

automaton R11 {
initially M11 and value = INITIAL & op = INITIAL & vc = ZERO;
  mode M11 { 
    invariant True;
    when click = EQ & op = DIV & vc = NON_ZERO may goto M11; value := DIV; op := INITIAL;
  }
}

manipulation

----------------------------------------
--   A user-defined sequential merge  --
----------------------------------------
--    graph g[1..total_automata-1];
--
--    for(i:=1; i<total_automata; i++) {
--      if(i = 1) {
--        g[1] := merge_graph(A[1], A[2]);
--      }
--      else {
--        g[i] := merge_graph(g[i-1], A[i+1]);
--      }
--      look_ahead(g[i-1], g[i]);
--      shield_clock(g[i]);
--      normalize_region(g[i]);
--    }
--    model_check(g[total_automata-1]);
--    print_graph(g[total_automata-1]);
----------------------------------------

----------------------------------------
--   System-defined sequential merge  --
----------------------------------------
    sequential_merge();
--      pairwise_merge();
--    look_ahead();
    read_write();
--   shield_clock();
--    normalize_region();
--    transition_bypass();
--    print_graph();
--    model_check();
