total_automata 2;
clock x[1..total_automata];
register ub, lb;

--------------------------------------------------------------------------
automaton A[i] {
initially M1 and ub = 1 and lb = 2 and x[i] = 0;
  mode M1 { 
    invariant x[i] < 2;
    when x[i] >= 1 may goto M1; x[i] := 0;
  }
}

--verify all_paths ( not {(~(lock = i) and x[i] <= 1) or (lock = 3)}  
--                   and (mode(A[1]) != M1)
--                  until >= 1
--                   {(mode(A[2]) != M3) or (mode(A[1]) = M1)}
--                   and (mode(A[2]) = M3)
--                 )
--       and exists_path (eventually {
--                         (henceforth not {(mode(A[1]) = M4) and 
--                                          (mode(A[2]) = M4)})
--                                   })
--;

--verify all_paths (henceforth not{(mode(A[1]) = M4) and (mode(A[2]) = M4)}
--                         and not{(mode(A[1]) = M4) and (mode(A[3]) = M4)}
--                         and not{(mode(A[2]) = M4) and (mode(A[3]) = M4)}
--                 );

--verify ~(mode(A[1]) = M4 and 
--         ~(mode(A[2]) = M4 or (mode(A[1]) = M3 or mode(A[1])=M4) and
--           mode(A[2]) = M2
--          )
--         or mode(A[2]) = M1
--        )
--        and 
--        (mode(A[2]) != M1) or 
--       ~(mode(A[1]) = M3 or mode(A[2]) = M3);


manipulation

----------------------------------------
--   A user-defined sequential merge  --
----------------------------------------
--    graph g[1..total_automata-1], g[1];
--
--    for(i:=1; i<total_automata; i++) {
--      if(i = 1) {
--        g[1] := merge_graph(A[1], A[2]);
--      }
--      else {
--        g[i] := merge_graph(g[i-1], A[i+1]);
--      }
--      look_ahead(g[i-1], g[i]);
--      shield_clock(g[i]);
--      normalize_region(g[i]);
--    }
--    model_check(g[total_automata-1]);
--    print_graph(g[total_automata-1]);
----------------------------------------

----------------------------------------
--   System-defined sequential merge  --
----------------------------------------
    sequential_merge();
--      pairwise_merge();
--    look_ahead();
    read_write();
    shield_clock();
    normalize_region();
--    print_graph();
--    model_check();
----------------------------------------

----------------------------------------
--    if(num_modes(g[1]) < num_modes(g[2])) {
--      model_check(g[1]);
--    }
--    if(num_trans(g[2]) < num_trans(A[1])) {
--      model_check(A[1]);
--    }

--  graph gg, y2, x3, g[1..total_automata-1];
--    for(i:=0; i<total_automata; i++) {
--      if(i=1) {
--       g[1] := merge_graph(A[1], A[2]);
--        look_ahead(g[2], x3);
--        if(i <= 3) {
--          look_ahead(g[2], x3);
--        }
--      }
--      else {
--        x3 = merge_graph(A[1], A[3]);
--        look_ahead();
--        look_ahead(g[1], A[3]);
--      }
--    }
--    for(i:=0; i<total_automata; i++) {
--      g[2] := merge_graph(g[1], y2);
--      for(i=0; i<total_automata; i++) {
--        g[2] := merge_graph(g[1], y2);
--        look_ahead(A[3], y2);
--      }
--      look_ahead(A[3], y2);
--    }
--    look_ahead(A[1], A[3]);
--    model_check(g[2]);
