automata Sender : i = 1..25;
clock x[1..total(Sender)];
register channel, user;

--------------------------------------------------------------------------
automaton Sender[i] {
initially Idle and 
          channel = 0 &      --  channel=0 => free, channel=1 =>in_use
          user = 0 and       --  user => last user index
          x[i] = 0;          --  x[i] => local clock
  mode Idle {
    invariant True;
    when channel = 0 may goto Ready; x[i] := 0;
  }
  mode Ready{
    invariant x[i] <= 1;
    when x[i] = 1 and channel = 1            may goto Collision; 
                                             x[i] := 0;
    when x[i] = 1 and user != 0              may goto Collision; 
                                             x[i] := 0; user := 0;
    when x[i] = 1 and user = 0 & channel = 0 may goto Transmit; 
                                             x[i] := 0; user := i;
  }
  mode Collision{
    invariant x[i] <= 2;
    when x[i] <= 2 and channel = 0 may goto Ready; x[i] := 0;
    when channel = 1 may goto Collision; x[i] := 0;
  }
  mode Transmit{
    invariant x[i] <= 2;
    when x[i] <= 2 and user != i may goto Collision; x[i] := 0; user := 0;
    when x[i] = 2 and user = i & channel = 0 may goto Safe_Transmit; 
                                                      channel := 1;
  }
  mode Safe_Transmit{
    invariant True;
    when x[i] > 2 and user = i & channel = 1 may goto Idle; 
                                         user := 0; channel := 0; x[i] := 0;
  }
}

manipulation

----------------------------------------
--   A user-defined sequential merge  --
----------------------------------------
--    graph g[1..total_automata-1], g[1];
--
--    for(i:=1; i<total_automata; i++) {
--      if(i = 1) {
--        g[1] := merge_graph(A[1], A[2]);
--      }
--      else {
--        g[i] := merge_graph(g[i-1], A[i+1]);
--      }
--      look_ahead(g[i-1], g[i]);
--      shield_clock(g[i]);
--      normalize_region(g[i]);
--    }
--    model_check(g[total_automata-1]);
--    print_graph(g[total_automata-1]);
----------------------------------------

----------------------------------------
--   System-defined sequential merge  --
----------------------------------------
    sequential_merge();
    read_write();
    normalize_region();
    shield_clock();
--    transition_bypass();
--    print_graph();
----------------------------------------
