automata A : i = 1..11;
clock x[1..total(A)];
register lock;

--------------------------------------------------------------------------
automaton A[i] {
initially M1 and lock = 0 and x[i] = 0;
  mode M1 { 
    invariant True;
    when lock = 0 may goto M2; x[i] := 0;
  }
  mode M2{ 
    invariant x[i] < 1;
    when x[i] < 1 may goto M3; x[i] := 0; lock := i;
  }
  mode M3{ 
    invariant True;
    when x[i] >= 1 and lock = i may goto M4;
    when ~(lock = i) may goto M1;
  }
  mode M4{
    invariant True;
    when True may goto M1; lock := 0;
  }
}

--verify all_paths (henceforth not{(mode(A[1]) = M4) and (mode(A[2]) = M4)}
--                         and not{(mode(A[1]) = M4) and (mode(A[3]) = M4)}
--                         and not{(mode(A[2]) = M4) and (mode(A[3]) = M4)}
--                 );

manipulation

----------------------------------------
--   A user-defined sequential merge  --
----------------------------------------
--    graph g[1..3];
--
--    for(i:=1; i<4; i++) {
--      if(i = 1) {
--        g[1] := merge_graph(A[1], A[2]);
--      }
--      else {
--        g[i] := merge_graph(g[i-1], A[i+1]);
--      }
--    }
--    read_write(g[i-1]);
--    shield_clock(g[i-1]);
--    normalize_region(g[i-1]);
--
--    model_check(g[total_automata-1]);
--    print_graph(g[total_automata-1]);
----------------------------------------

----------------------------------------
--   System-defined sequential merge  --
----------------------------------------
    sequential_merge();
    read_write();
    shield_clock();
    normalize_region();
--    transition_bypass();   -- No use
--    print_graph();
