-------------------------------------------------------------------------
--       A small mutual-exclusion example based on Fischer's MEP       --
-------------------------------------------------------------------------

-- (A) System Description --

  -- (A.1) Variable declaration

automata A : i = 1..12;
clock x[1..total(A)];
register lock;

  -- (A.2) Timed Automata description

automaton A[i] {
initially M1 and lock = 0 and x[i] = 0;
  mode M1 { 
    invariant True;
    when lock = 0 may goto M2; x[i] := 0; lock := i;
  }
  mode M2{ 
    invariant True;
    when x[i] > 1 may goto M1; lock := 0;
  }
}

-------------------------------------------------------------------------
-- (B) TCTL Specification --

verify all_paths (henceforth not{(mode(A[1]) = M2) and (mode(A[2]) = M2)}
                         and not{(mode(A[1]) = M2) and (mode(A[3]) = M2)}
                         and not{(mode(A[2]) = M2) and (mode(A[3]) = M2)}
                 );

-------------------------------------------------------------------------
-- (C) State-Graph Manipulation --

manipulation

----------------------------------------
--   A user-defined sequential merge  --
----------------------------------------
--    graph g[1..total_automata-1];

--    for(i:=1; i<total_automata; i++) {
--      if(i = 1) {
--        g[1] := merge_graph(A[1], A[2]);
--      }
--      else {
--        g[i] := merge_graph(g[i-1], A[i+1]);
--      }
--      look_ahead(g[i-1], g[i]);
--      normalize_region(g[i]);
--      shield_clock(g[i]);
--    }
--    model_check(g[total_automata-1]);
--    print_graph(g[total_automata-1]);
----------------------------------------

----------------------------------------
--   System-defined sequential merge  --
----------------------------------------
    sequential_merge();
--      pairwise_merge();
--    look_ahead();
    read_write();
    transition_bypass();
    shield_clock();
    normalize_region();
--    print_graph();
--    model_check();
----------------------------------------
-------------------------------------------------------------------------
