var
Pt4 	: analog;
Pt3 	: analog;
Pt2 	: analog;
Pt1 	: analog;
Tt1 	: clock;
Cx1 	: clock;

automaton PE1
synclabs :sSp2,sSp3,sSp6,sEp6,sEp3,sEp2;
initially IDLE & Pt4=0;
loc IDLE: while True wait {dPt4=0}
          when asap sync sSp2  do {Pt4' = 0} goto p2;
          when asap sync sSp3  do {Pt4' = 0} goto p3;
          when asap sync sSp6  do {Pt4' = 0} goto p6;
loc p6: while Pt4 >= 0 & Pt4 <=4 wait {dPt4 = 1}
          when Pt4 = 4 sync sEp6  do {Pt4' =0} goto IDLE;
loc p3: while Pt4 >= 0 & Pt4 <=30 wait {dPt4 = 1}
          when Pt4 = 30 sync sEp3  do {Pt4' =0} goto IDLE;
loc p2: while Pt4 >= 0 & Pt4 <=20 wait {dPt4 = 1}
          when Pt4 = 20 sync sEp2  do {Pt4' =0} goto IDLE;
end

automaton IG
synclabs :sSp4,sSp5,sEp5,sEp4;
initially IDLE & Pt3=0;
loc IDLE: while True wait {dPt3=0}
          when asap sync sSp4  do {Pt3' = 0} goto p4;
          when asap sync sSp5  do {Pt3' = 0} goto p5;
loc p5: while Pt3 >= 0 & Pt3 <=25 wait {dPt3 = 1}
          when Pt3 = 25 sync sEp5  do {Pt3' =0} goto IDLE;
loc p4: while Pt3 >= 0 & Pt3 <=600 wait {dPt3 = 1}
          when Pt3 = 600 sync sEp4  do {Pt3' =0} goto IDLE;
end

automaton DS
synclabs :sSp7,sEp7;
initially IDLE & Pt2=0;
loc IDLE: while True wait {dPt2=0}
          when asap sync sSp7  do {Pt2' = 0} goto p7;
loc p7: while Pt2 >= 0 & Pt2 <=10 wait {dPt2 = 1}
          when Pt2 = 10 sync sEp7  do {Pt2' =0} goto IDLE;
end

automaton TS
synclabs :sSp1,sEp1;
initially IDLE & Pt1=0;
loc IDLE: while True wait {dPt1=0}
          when asap sync sSp1  do {Pt1' = 0} goto p1;
loc p1: while Pt1 >= 0 & Pt1 <=100 wait {dPt1 = 1}
          when Pt1 = 100 sync sEp1  do {Pt1' =0} goto IDLE;
end

automaton Entry
synclabs :sSp1,sEp1,sSp2,sEp2,sFp22,sSp3,sEp3,sSp4,sEp4,sSp5,sEp5,sJEND2;
initially START & Tt1=0 & Cx1=0;
loc START: while True wait {}
          when asap sync sSp1  do {} goto Sp1;
loc Sp1: while True wait {}
          when True sync sEp1  do {} goto Ep1;
loc Ep1: while True wait {}
          when asap sync sSp2 do {} goto Sp2;
loc Sp2: while True wait {}
          when True sync sEp2  do {} goto Ep2;
loc Ep2: while True wait {}
          when asap sync sFp22  do {} goto Fp22;
loc Fp22: while True wait {}
          when asap sync sSp3 do {} goto Sp3;
loc Sp3: while True wait {}
          when True sync sEp3  do {} goto Ep3;
loc Ep3: while True wait {}
          when asap sync sSp4 do {} goto Sp4;
loc Sp4: while True wait {}
          when True sync sEp4  do {} goto Ep4;
loc Ep4: while True wait {}
          when asap sync sSp5 do {} goto Sp5;
loc Sp5: while True wait {}
          when True sync sEp5  do {} goto Ep5;
loc Ep5: while True wait {}
          when asap sync sJEND2  do {Cx1' = 0} goto JEND2;
loc JEND2: while  Cx1 = 0 wait {}
          when Tt1 <= 1900 do {} goto DELAY;
          when Tt1 > 1900 do {} goto lERROR;
loc DELAY: while Tt1 <=2000 wait {}
          when Tt1=2000  do {Tt1' = 0} goto START;
loc lERROR: while True wait {}
          when False do {} goto lERROR;
end

automaton p2p6
synclabs :sFp22,sSp6,sEp6,sSp7,sEp7,sJEND2;
initially IDLE ;
loc IDLE: while True wait {}
          when True sync sFp22 do {} goto START;
loc START: while True wait {}
          when asap sync sSp6 do {} goto Sp6;
loc Sp6: while True wait {}
          when True sync sEp6  do {} goto Ep6;
loc Ep6: while True wait {}
          when asap sync sSp7 do {} goto Sp7;
loc Sp7: while True wait {}
          when True sync sEp7  do {} goto Ep7;
loc Ep7: while True wait {}
          when asap sync sJEND2 do {} goto IDLE;
end
var
init_reg, final_reg, reached, reached_viol : region;

init_reg:= loc[PE1]=IDLE & loc[IG]=IDLE & loc[DS]=IDLE &
 loc[TS]=IDLE & loc[Entry]=START & loc[p2p6]=IDLE &

 Pt4=0 & Pt3=0 & Pt2=0 & Pt1=0 & Tt1=0 ;
final_reg:= loc[Entry]=lERROR ;

reached:= reach forward from init_reg endreach;

reached_viol:= reached & final_reg;
if empty (reached_viol)
  then prints "Finish";
       print reached;
  else prints "Can't satisfy";
       print trace to final_reg using reached;
endif;
