var
Pt4 	: analog;
Pt3 	: analog;
Pt2 	: analog;
Pt1 	: analog;
Tt1 	: clock;
Cx1 	: clock;

automaton PE2
synclabs :sSp9,sEp9,sSp12,sEp12;
initially IDLE & Pt4=0;
loc IDLE: while True wait {dPt4=0}
          when asap sync sSp9  do {Pt4' = 0} goto p9;
loc p9: while Pt4 >= 0 & Pt4 <=300 wait {dPt4 = 1}
          when Pt4 = 300 sync sEp9  do {Pt4' =0} goto Ip9;
loc Ip9: while True wait {dPt4=0}
          when asap sync sSp12  do {Pt4' = 0} goto p12;
loc p12: while Pt4 >= 0 & Pt4 <=4 wait {dPt4 = 1}
          when Pt4 = 4 sync sEp12  do {Pt4' =0} goto IDLE;
end

automaton OG
synclabs :sSp10,sEp10,sSp11,sEp11;
initially IDLE & Pt3=0;
loc IDLE: while True wait {dPt3=0}
          when asap sync sSp10  do {Pt3' = 0} goto p10;
loc p10: while Pt3 >= 0 & Pt3 <=600 wait {dPt3 = 1}
          when Pt3 = 600 sync sEp10  do {Pt3' =0} goto Ip10;
loc Ip10: while True wait {dPt3=0}
          when asap sync sSp11  do {Pt3' = 0} goto p11;
loc p11: while Pt3 >= 0 & Pt3 <=25 wait {dPt3 = 1}
          when Pt3 = 25 sync sEp11  do {Pt3' =0} goto IDLE;
end

automaton DS
synclabs :sSp13,sEp13;
initially IDLE & Pt2=0;
loc IDLE: while True wait {dPt2=0}
          when asap sync sSp13  do {Pt2' = 0} goto p13;
loc p13: while Pt2 >= 0 & Pt2 <=10 wait {dPt2 = 1}
          when Pt2 = 10 sync sEp13  do {Pt2' =0} goto IDLE;
end

automaton TC
synclabs :sSp8,sEp8;
initially IDLE & Pt1=0;
loc IDLE: while True wait {dPt1=0}
          when asap sync sSp8  do {Pt1' = 0} goto p8;
loc p8: while Pt1 >= 0 & Pt1 <=100 wait {dPt1 = 1}
          when Pt1 = 100 sync sEp8  do {Pt1' =0} goto IDLE;
end

automaton Exit
synclabs :sSp8,sEp8,sSp9,sEp9,sFp92,sSp10,sEp10,sSp11,sEp11,sJEND2;
initially START & Tt1=0 & Cx1=0;
loc START: while True wait {}
          when asap sync sSp8  do {} goto Sp8;
loc Sp8: while True wait {}
          when True sync sEp8  do {} goto Ep8;
loc Ep8: while True wait {}
          when asap sync sSp9 do {} goto Sp9;
loc Sp9: while True wait {}
          when True sync sEp9  do {} goto Ep9;
loc Ep9: while True wait {}
          when asap sync sFp92  do {} goto Fp92;
loc Fp92: while True wait {}
          when asap sync sSp10 do {} goto Sp10;
loc Sp10: while True wait {}
          when True sync sEp10  do {} goto Ep10;
loc Ep10: while True wait {}
          when asap sync sSp11 do {} goto Sp11;
loc Sp11: while True wait {}
          when True sync sEp11  do {} goto Ep11;
loc Ep11: while True wait {}
          when asap sync sJEND2  do {Cx1' = 0} goto JEND2;
loc JEND2: while  Cx1 = 0 wait {}
          when Tt1 <= 1850 do {} goto DELAY;
          when Tt1 > 1850 do {} goto lERROR;
loc DELAY: while Tt1 <=2000 wait {}
          when Tt1=2000  do {Tt1' = 0} goto START;
loc lERROR: while True wait {}
          when False do {} goto lERROR;
end

automaton p9p12
synclabs :sFp92,sSp12,sEp12,sSp13,sEp13,sJEND2;
initially IDLE ;
loc IDLE: while True wait {}
          when True sync sFp92 do {} goto START;
loc START: while True wait {}
          when asap sync sSp12 do {} goto Sp12;
loc Sp12: while True wait {}
          when True sync sEp12  do {} goto Ep12;
loc Ep12: while True wait {}
          when asap sync sSp13 do {} goto Sp13;
loc Sp13: while True wait {}
          when True sync sEp13  do {} goto Ep13;
loc Ep13: while True wait {}
          when asap sync sJEND2 do {} goto IDLE;
end
var
init_reg, final_reg, reached, reached_viol : region;

init_reg:= loc[PE2]=IDLE & loc[OG]=IDLE & loc[DS]=IDLE &
 loc[TC]=IDLE & loc[Exit]=START & loc[p9p12]=IDLE &

 Pt4=0 & Pt3=0 & Pt2=0 & Pt1=0 & Tt1=0 ;
final_reg:= loc[Exit]=lERROR ;

reached:= reach forward from init_reg endreach;

reached_viol:= reached & final_reg;
if empty (reached_viol)
  then prints "Finish";
       print reached;
  else prints "Can't satisfy";
       print trace to final_reg using reached;
endif;
