-- VPMS
automata Entry, Exit, Display;

register	count;	-- counter value
clock		t,	-- process execution times
		x;	-- accumulated total time

automaton Display {

synclabs: car_in, 	-- A signal to announce Car Entry through gate
	  car_out, 	-- A signal to announce Car Exit through gate
	  time_stamp;	-- A signal to indicate Time-Stamp Button is pushed

initially Update & count = 500 	-- 500 Parking Spaces
		 & t = 0 & x = 0;

mode Update { invariant t <= 1000;
	when t = 1000 may goto Polling; t:=0; x:=0;

mode Polling {	invariant True;
	when t = 5 & x <= 33000 goto Update; t:=0; x:=0;
	when True sync car_out goto Increment_Counter; t:=0;
	when True sync car_in goto Decrement_Counter; t:=0;
	when True sync time_stamp goto Read_Counter; t:=0;

mode Increment_Counter { invariant t <= 3;
	when t = 3 & x <= 33000 goto Update_Display; 
                                t:=0; x:=0; count = count + 1;

mode Decrement_Counter { invariant t <= 3;
	when t = 3 & x <= 33000 goto Update_Display;
                                t:=0; x:=0; count = count - 1;

mode Read_Counter { invariant t <= 1;
	when t = 1 goto Polling; t:=0;
}

