---VPMS
automata Environment, Entry, Exit, Display;

--local variables
register	count;	--counter value
clock		td,	--local clock of display
		tx,	--local clock of exit
		ty;	--local clock of entry

automaton Environment {

synclabs no_ticket_out, push_button, ticket_insert, ticket_error,
	 ticket_out, ticket_ok, take_ticket, initialize, update_dboard, 
         time_out1, time_out2;

initially Env_Idle;

mode Env_Idle {
	invariant True;
	when True sync push_button may goto Wait_PTS;
	when True sync ticket_insert may goto Wait_Ticket_Checking;	
	when True sync initialize may goto Wait_Update;
}

mode Wait_PTS {
	invariant True;
	when True sync no_ticket_out may goto Env_Idle;
	when True sync ticket_out may goto See_Ticket_Out;
}

mode Wait_Ticket_Checking {
	invariant True;
	when True sync ticket_error may goto Env_Idle;
	when True sync ticket_ok may goto Wait_Update;
}

mode See_Ticket_Out {
	invariant True;
	when True sync take_ticket may goto Wait_Update;
}

mode Wait_Update {
	invariant True;
	when True sync time_out1 may goto Env_Idle;
	when True sync time_out2 may goto Env_Idle;
	when True sync update_dboard may goto Update_DBoard;
} 

mode Update_DBoard {
	invariant True;
	when True may goto Env_Idle;
}
}

automaton Display{

synclabs initialize, update_dboard, car_in, car_out, count_request,
	 count_zero, count_above_zero;

initially D_Init;

mode D_Init{
	invariant True;
	when True sync initialize may goto Update_Display;
		count := 500; td :=0;
}

mode Update_Display { 
	invariant True;
	when True sync update_dboard may goto DBoard_Updating;
}

mode DBoard_Updating { 
	invariant td <=100 ;
	when td = 100 may goto D_Idle;
}

mode D_Idle { 
	invariant True;
	when True sync car_out may goto Increment_Counter; 
		td:=0;
	when True sync car_in may goto Decrement_Counter; 
		td:=0; 
	when True sync count_request may goto Read_Counter; 
		td:=0; 
}

mode Increment_Counter { 
	invariant td <= 42;
	when td = 42 may goto Update_Display;
		td := 0; count := count + 1 (mod 500); 
}

mode Decrement_Counter { 
	invariant td <= 42;
	when td = 42 may goto Update_Display;
		td := 0; count := count - 1 (mod 500); 
} 

mode  Read_Counter { 
	invariant td <= 18;
	when td = 18  sync count_zero may goto D_Idle;         
	when td = 18  sync count_above_zero may goto D_Idle; 
} 
}


automaton Entry {

synclabs push_button, count_request, count_above_zero, count_zero, no_ticket_out,
	 ticket_out, take_ticket, time_out1, car_in; 

initially Ent_Idle;

mode Ent_Idle {
	invariant True;
	when True sync push_button may goto Check_Space;
}

mode Check_Space {
	invariant True;
	when True sync count_request may goto Read_Count;
		ty:=0;
}

mode Read_Count {
	invariant ty <= 200;
	when ty = 200 sync count_zero may goto Reply_User;  
	when ty = 200 sync count_above_zero may goto Process_Time_Stamp;
		ty:=0;
}

mode Reply_User {
	invariant True;
	when True sync no_ticket_out may goto Ent_Idle;
}

mode Process_Time_Stamp {
	invariant True;
	when True sync ticket_out may goto Wait_User;
}

mode Wait_User {
	invariant True;
	when True sync take_ticket may goto Open_Entry_Gate;
}

mode Open_Entry_Gate {
	invariant True;
	when True sync time_out1 may goto Close_Entry_Gate;
		ty:=0;
	when ty >= 244 sync car_in may goto Close_Entry_Gate;
		ty:=0;
}

mode Close_Entry_Gate {
	invariant True;
	when ty >= 244 may goto Ent_Idle;
}
}

automaton Exit {

synclabs ticket_insert, ticket_error, ticket_ok, time_out2, car_out;

initially Ex_Idle;

mode Ex_Idle {
	invariant True;
	when True sync ticket_insert may goto Check_Ticket;
		tx:=0;
}

mode Check_Ticket {
	invariant True;
	when True sync ticket_error may goto Ex_Idle;
	when True sync ticket_ok may goto Open_Exit_Gate; 
		tx:=0;
}

mode Open_Exit_Gate {
	invariant True;
	when True sync time_out2 may goto Close_Exit_Gate; 
		tx:=0;
	when tx >= 244 sync car_out may goto Close_Exit_Gate; 
		tx:=0;
}

mode Close_Exit_Gate {
	invariant True;
	when tx >= 244 may goto Ex_Idle;
}
}

manipulation
	sequential_merge();
	read_write();
	shield_clock();
	transition_bypass();
	
