
struct trans_link_type {
  struct transition_type *transition;
  struct trans_link_type *next;
} ;

struct mode_link_type {
  struct mode_type *mode;
  struct mode_link_type *next;
} ;

struct mode_mu_type {
  int index, visited;
  int count;                            /* used by 23tree */    
  struct a23tree_type *parent;          /* used by 23tree */    
  struct mode_type *Mode;
  struct mode_link_type *mode_cycle;
  struct clkconj_type *mu_clk;
  bdd mu_prp;
  struct mm_transition_type *out_mm_trans_cycle,
                            *in_mm_trans_cycle;
  struct mode_mu_type *next;
} ;

struct mode_mu_link_type {
  struct mode_mu_type *mode_mu;
  struct mode_mu_link_type *next;
} ;

struct mm_transition_type {
  int index;
  int weight;
  struct mode_mu_type *mode_mu;
  struct mode_type *from_mode;
  struct mode_type *to_mode;
  struct mm_transition_type *next;
} ;

extern struct a23tree_type *mode_mu_tree;

extern int back_reduce(struct thread_type *t);
extern struct mode_mu_type *alloc_mode_mu();
extern int back_path(struct mode_type *, struct transition_type *);
extern int consistent_inv_mu(struct mode_type *, struct clkconj_type *, bdd);
extern int back_dfs(struct mode_mu_type *);
extern int calculate_weight(struct mode_type *, struct mode_type *);
extern struct mode_link_type *copy_mode_link_cycle(struct mode_link_type *);
extern struct mode_link_type *insert_mode(struct mode_type *, 
                                          struct mode_link_type *);
extern int exist_mode(struct mode_type *, struct mode_link_type *);
extern int print_mode_link_cycle(struct mode_link_type *);
extern int mode_mu_comp(struct mode_mu_type *, struct mode_mu_type *);
extern struct mode_link_type *delete_mode(struct mode_type *, 
                                          struct mode_link_type *);
extern int free_mode_mu(struct mode_mu_type *);
extern int mode_mu_count_inc(struct mode_mu_type *);
extern int mode_mu_parent_set(struct mode_mu_type *, struct a23tree_type *);
extern int print_mode_mu(struct mode_mu_type *);
extern struct clkconj_type *back_delta(struct clkconj_type *, int);
extern int initial_consistent(struct mode_mu_type *);
extern struct clkconj_type *reset_clk_assign(struct clkconj_type *,
                                             struct assign_type *);
extern bdd reset_prp_assign(bdd, struct assign_type *);
extern struct clkconj_type *weakest_clk_precondition(struct transition_type *,
                                                     struct mode_mu_type *,
                                                     struct clkconj_type *);
extern bdd weakest_prp_precondition(struct transition_type *, 
                                    struct mode_mu_type *);
extern int remove_dormant_cycles(struct thread_type *);
extern struct clkconj_type * back_clkconj_and(struct clkconj_type *, 
                                              struct clkconj_type *);
extern int back_compatible(int, int, int, int, int *, int *);
extern int is_initial_mode(struct mode_type *);
