C_COMPILER = gcc
#C_FLAGS = -O3 -Wall -D__SOLARIS
#C_FLAGS1 = -O3 -D__SOLARIS
C_FLAGS = -g -Wall -D__SOLARIS
C_FLAGS1 = -g -D__SOLARIS
#C_FLAGS = -ansi -g -D__SOLARIS

LEX = lex
YACC = yacc

INCLUDE_PATH = -I../../include
LIB_PATH = -L../../lib -L.
LIBS = -ll -lbdd -lmem -lm
GUILIBS = -lsgm -ll -lbdd -lmem -lm

OBJECTS = include.o print.o bddman.o modeman.o transman.o zoneman.o \
          symmetry.o shieldclk.o lf.o mcheck.o action.o proc.o \
          readwrite.o shieldvar.o gui.o help.o lex.yy.o y.tab.o
OTHER_OBJECTS = getresources.o treeman.o
HEADERS = include.h global.h print.h bddman.h modeman.h transman.h zoneman.h \
          symmetry.h shieldclk.h lf.h mcheck.h action.h proc.h \
          readwrite.h shieldvar.h getresources.h treeman.h treeman.e \
	  help.h gui.h 
SOURCES = main.c include.c print.c bddman.c modeman.c transman.c zoneman.c \
          symmetry.c shieldclk.c lf.c mcheck.c action.c proc.c\
          readwrite.c shieldvar.c getresources.c treeman.c help.c gui.c
YACC_SOURCES = vf.l vf.y
YACC_OUTPUTS = y.output y.tab.h y.tab.c lex.yy.c

all:		sgm

sgm:		$(OBJECTS) $(OTHER_OBJECTS) main.c
	$(C_COMPILER) $(C_FLAGS) $(INCLUDE_PATH) main.c $(OBJECTS) $(OTHER_OBJECTS) -o sgm $(LIB_PATH) $(LIBS)

lib:		$(OBJECTS) $(OTHER_OBJECTS) main.o
	$(AR) -r libsgm.a $(OBJECTS) $(OTHER_OBJECTS) main.o

main.o:		main.c include.h modeman.h
	$(C_COMPILER) $(C_FLAGS) -D_GUI $(INCLUDE_PATH) -c main.c -o main.o

include.o:	include.c include.h modeman.h
	$(C_COMPILER) $(C_FLAGS) $(INCLUDE_PATH) -c include.c -o include.o
print.o:	print.c include.h global.h
	$(C_COMPILER) $(C_FLAGS) $(INCLUDE_PATH) -c print.c -o print.o
bddman.o:	bddman.c bddman.h include.h global.h
	$(C_COMPILER) $(C_FLAGS) $(INCLUDE_PATH) -c bddman.c -o bddman.o
modeman.o:	modeman.c modeman.h transman.h include.h global.h zoneman.h symmetry.h readwrite.h
	$(C_COMPILER) $(C_FLAGS) $(INCLUDE_PATH) -c modeman.c -o modeman.o
transman.o:	transman.c transman.h modeman.h include.h global.h zoneman.h
	$(C_COMPILER) $(C_FLAGS) $(INCLUDE_PATH) -c transman.c -o transman.o
zoneman.o:	zoneman.c zoneman.h include.h global.h
	$(C_COMPILER) $(C_FLAGS) $(INCLUDE_PATH) -c zoneman.c -o zoneman.o
symmetry.o:	symmetry.c symmetry.h modeman.h include.h global.h
	$(C_COMPILER) $(C_FLAGS) $(INCLUDE_PATH) -c symmetry.c -o symmetry.o
shieldclk.o:	shieldclk.c shieldclk.h modeman.h include.h global.h
	$(C_COMPILER) $(C_FLAGS) $(INCLUDE_PATH) -c shieldclk.c -o shieldclk.o
lf.o:		lf.c lf.h modeman.h include.h global.h
	$(C_COMPILER) $(C_FLAGS) $(INCLUDE_PATH) -c lf.c -o lf.o
readwrite.o:	readwrite.c readwrite.h modeman.h include.h global.h
	$(C_COMPILER) $(C_FLAGS) $(INCLUDE_PATH) -c readwrite.c -o readwrite.o
shieldvar.o:	shieldvar.c shieldvar.h modeman.h include.h global.h
	$(C_COMPILER) $(C_FLAGS) $(INCLUDE_PATH) -c shieldvar.c -o shieldvar.o
mcheck.o:	mcheck.c mcheck.h include.h global.h modeman.h
	$(C_COMPILER) $(C_FLAGS) $(INCLUDE_PATH) -c mcheck.c -o mcheck.o
action.o:	action.c action.h include.h global.h gui.h
	$(C_COMPILER) $(C_FLAGS) $(INCLUDE_PATH) -c action.c -o action.o
gui.o:	gui.c gui.h include.h global.h
	$(C_COMPILER) $(C_FLAGS) $(INCLUDE_PATH) -c gui.c -o gui.o
help.o:		help.c help.h include.h global.h
	$(C_COMPILER) $(C_FLAGS) $(INCLUDE_PATH) -c help.c -o help.o
proc.o:		proc.c proc.h include.h global.h
	$(C_COMPILER) $(C_FLAGS) $(INCLUDE_PATH) -c proc.c -o proc.o

getresources.o:		getresources.c getresources.h
	$(C_COMPILER) $(C_FLAGS) $(INCLUDE_PATH) -c getresources.c -o getresources.o
treeman.o:	treeman.c treeman.h
	$(C_COMPILER) $(C_FLAGS1) $(INCLUDE_PATH) -c treeman.c -o treeman.o
setman.o:	setman.c setman.h
	$(C_COMPILER) $(C_FLAGS) $(INCLUDE_PATH) -c setman.c -o setman.o

lex.yy.o:       lex.yy.c y.tab.h include.h global.h
	$(C_COMPILER) $(C_FLAGS1) $(INCLUDE_PATH) -c lex.yy.c -o lex.yy.o
lex.yy.c:       vf.l
	$(LEX) vf.l

y.tab.o:        y.tab.c y.tab.h include.h global.h
	$(C_COMPILER) $(C_FLAGS1) $(INCLUDE_PATH) -c y.tab.c -o y.tab.o
y.tab.h y.tab.c:        vf.y
	$(YACC) -vd vf.y

gui_test: gui_test.c
	$(C_COMPILER) $(C_FLAGS) $(INCLUDE_PATH) gui_test.c -o gui_test $(LIB_PATH) $(GUILIBS)
	
clean:		
	/bin/rm -f sgm libsgm.a gui_test $(OBJECTS) $(YACC_OUTPUTS) core *.log main.o

distclean:
	/bin/rm -f sgm libsgm.a gui_test $(OBJECTS) $(OTHER_OBJECTS) $(YACC_OUTPUTS) core *.log examples/*/*.log main.o

backup:		makefile $(HEADERS) $(YACC_SOURCES) $(SOURCES)
	/bin/cp -f makefile $(HEADERS) $(YACC_SOURCES) $(SOURCES) backup
