#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "include.h"
#include "global.h"
#include "gui.h"
#define MSG_LEN 1000

char *fifo_name = "/tmp/sgm.fifo";
int sgm_fifo;

int gen_fifo(void);
int setflush(void);

int process_mode() {
  int i, cmd_len;
  char request[MSG_LEN];
/*
  pid_t sgm_pid = getpid();
*/

  setflush();

  while(TRUE) {
/*
    printf("CMD> "); fflush(stdout);
*/
    if( (cmd_len = read(STDIN_FILENO, request, MSG_LEN)) < 0 )
      fprintf(stderr, "SGM: Read error from SGM FIFO.\n");
    else {
/*
      write(STDERR_FILENO, "Child got request: ", 19);
      write(STDERR_FILENO, request, cmd_len);
*/
      request[cmd_len-1] = 0;
      RequestFromGUI(request, 0);
#ifndef __SOLARIS
      write(STDOUT_FILENO, "@@", 2);
#endif
      if(answer) {
        for(i=0; answer[i]; i++) {
          write(STDOUT_FILENO, answer[i], strlen(answer[i]));
#ifndef __SOLARIS
          write(STDOUT_FILENO, "@@", 2);
#endif
        }
      }
#ifndef __SOLARIS
      write(STDOUT_FILENO, "@@", 2);
#else
      write(STDOUT_FILENO, "", 0);
#endif
      /*print_answer();*/
    }
    reset_str(request, MSG_LEN);
  }
}

int gen_fifo() {
  struct stat f;

  if(access(fifo_name, F_OK) < 0) {
    if(mkfifo(fifo_name, S_IRUSR | S_IWUSR) < 0)
      fprintf(stderr, "Make SGM FIFO Error!\n");
  }
  else {
    if(stat(fifo_name, &f) < 0)
      fprintf(stderr, "File Stat Failed!\n");
    if(S_ISFIFO(f.st_mode) == 0)
      fprintf(stderr, "File with name %s exists!\n"
                      "SGM needs that filename for making a FIFO.\n"
                      "Please delete/rename that file first!\n", fifo_name);
    else if(access(fifo_name, R_OK | W_OK) < 0) {
      fprintf(stderr, "SGM FIFO exists and is not readable/writable!\n"
                      "Changing mode of FIFO %s into user readable/writable.\n",
                      fifo_name);
      if(chmod(fifo_name, S_IRUSR | S_IWUSR) < 0)
        fprintf(stderr, "SGM FIFO chmod failed!\n");
    }
    else 
      fprintf(stderr, "SGM FIFO exists and is readable/writable!\n");
  }

  if( (sgm_fifo = open(fifo_name, O_RDWR)) < 0)
    fprintf(stderr, "Open SGM FIFO Error!\n");
  return 0;
}

int setflush() {
  if(setvbuf(stderr, NULL, _IOLBF, 0) != 0)
    fprintf(stderr, "SGM: stdout setvbuf error.\n");
  if(setvbuf(stdin, NULL, _IOLBF, 0) != 0)
    fprintf(stderr, "SGM: stdin setvbuf error.\n");
  if(setvbuf(stdout, NULL, _IOLBF, 0) != 0)
    fprintf(stderr, "SGM: stdout setvbuf error.\n");
  return 0;
}
