#ifndef __READWRITE_H
#define __READWRITE_H

extern int total_dvar;    /* total number of discrete variables */
extern int **val_count;   /* val_count[i][j] => i : thread index
                           *                    j : discrete variable ordering
                           *  i.e., thread[i] writes "val_count[i][j]" values
                           *  to the discrete variable with
                           *  index "varval[i][j][0]"
                           */
extern int ***varval;
  /* varval[i][j][k] => i : thread index
   *                    j : discrete variable index (varval[i][j][0])
   *                    k : 0     --> variable index
   *                        1 ... --> values written by thread[i] to
   *                                  variable varval[i][j][0]
   */

extern int get_dvar_id(int, struct automaton *);

extern int varval_written(int v, int, struct thread_type *);

extern int component_graph(int id, struct thread_type *t);
extern struct boolconj_type *initial_dvl(struct thread_type *t1,
                                  struct thread_type *t2,
                                  int is_initial_mode, struct variable_type *);
extern int readwrite_reduce(struct thread_type *);
extern int init_varval();
extern int varval_written_auto(int, int, struct automaton *);
extern struct boolconj_type *get_new_dvl(struct mode_type *m,
                                  struct transition_type *tr);
#endif
