
#include <stdio.h>
#include <ctype.h>

#include	"setman.h"

#define	FALSE	0
#define	TRUE	1 
#define	FOREVER	1 

extern	FILE	*out; 


int	*ELEMENT_MASK; 

int			set_link_count, free_set_link_count; 
struct set_link_type	*set_link_pool; 

init_set_management()
{
  int	i, j; 

  ELEMENT_MASK = (int *) malloc(WORDSIZE * sizeof(int)); 

  for (i = 0, j = 1; i < WORDSIZE; i++, j = 2 * j)
    ELEMENT_MASK[i] = j; 

  set_link_count = free_set_link_count = 0;
  set_link_pool = NULL; 
}
  /* init_set_management() */ 



struct set_class_type	*init_setclass_management(universe_size, element_name)
     int	universe_size; 
     char	**element_name; 
{
  struct set_class_type	*set_class; 
  int			i; 

  set_class = (struct set_class_type *) malloc(sizeof(struct set_class_type)); 
  set_class->universe_size = universe_size;
  set_class->element_name = element_name; 
  set_class->mask_count = set_class->universe_size / WORDSIZE; 
  if (set_class->universe_size % WORDSIZE)
    (set_class->mask_count)++; 
  set_class->free_set_count = 0; 
  set_class->free_set_list = NULL; 

  set_class->last_mask = 0; 
  if (set_class->universe_size) 
    if (i = (set_class->universe_size % WORDSIZE)) {
      for (i--; i>=0; i--)
	set_class->last_mask = set_class->last_mask | ELEMENT_MASK[i]; 
    }
    else 
      set_class->last_mask = ~(set_class->last_mask); 
    
  return(set_class); 
}
  /* alloc_set_class() */ 




print_set_class(set_class)
     struct set_class_type	*set_class; 
{
  int	i; 

  fprintf(out, "\nSet class %x with size = %d\n", 
	  set_class, set_class->universe_size); 
  for (i = 0; i < set_class->universe_size; i++)
    fprintf(out, "%d %s with mask %d in word %d.\n", 
	    i, set_class->element_name[i], ELEMENT_MASK[i % WORDSIZE], i / WORDSIZE); 
}
  /* print_set_class() */




print_set(set, set_class)
     int			*set; 
     struct set_class_type	*set_class; 
{
  int	i; 

  if (set) { 
    fprintf(out, "{ "); 
    for (i = 0; i < set_class->universe_size; i++)
      if (set[i / WORDSIZE] & ELEMENT_MASK[i % WORDSIZE]) {
	fprintf(out, "%s", set_class->element_name[i]); 
	break;
      }

    for (i++; i < set_class->universe_size; i++)
      if (set[i / WORDSIZE] & ELEMENT_MASK[i % WORDSIZE]) 
	fprintf(out, ", %s", set_class->element_name[i]); 

    fprintf(out, " } "); 
  }
  else {
    fprintf(out, "a NULL set! "); 
  }
}
  /* print_set() */



print_selected_set(set, mask, set_class)
     int			*set, *mask; 
     struct set_class_type	*set_class; 
{
  int	i; 

  fprintf(out, "{ "); 
  for (i = 0; i < set_class->universe_size; i++)
    if ((set[i / WORDSIZE] & mask[i / WORDSIZE]) & ELEMENT_MASK[i % WORDSIZE]) {
      fprintf(out, "%s", set_class->element_name[i]); 
      break;
    }

  for (i++; i < set_class->universe_size; i++)
    if ((set[i / WORDSIZE] & mask[i / WORDSIZE]) & ELEMENT_MASK[i % WORDSIZE]) 
      fprintf(out, ", %s", set_class->element_name[i]); 

  fprintf(out, " }\n"); 
}
  /* print_set() */



print_set_xrep(set, set_class)
     set_type			*set; 
     struct set_class_type	*set_class; 
{
  int	i; 

  for (i = set_class->mask_count - 1; i >= 0; i--)
    fprintf(out, " %x", set[i]); 
}
  /* print_set_xrep() */ 



int	*alloc_set(set_class)
     struct set_class_type	*set_class; 
{
  int	*set, i; 

  if (set_class->free_set_count) {
/*    fprintf(out, "@@@Alloc old set %x in class %x with fsc %d.\n", 
 *	    set_class->free_set_list, set_class, set_class->free_set_count); 
 *    fflush(out); 
 */
    set = set_class->free_set_list; 
    set_class->free_set_list = (int *) *set; 
    (set_class->free_set_count)--; 
  }
  else {
    set = (int *) malloc(set_class->mask_count * sizeof(int)); 
/*    fprintf(out, "@@@Alloc new set %x in class %x with fsc %d.\n", 
 *	    set, set_class, set_class->free_set_count); 
 *    fflush(out); 
 */
  }


  for (i = 0; i < set_class->mask_count; i++)
    set[i] = 0; 

  return(set); 
}
  /* alloc_set() */



free_set(set, set_class)
     int			*set; 
     struct set_class_type	*set_class; 
{
/*  fprintf(out, "@@@Free set %x in class %x with fsc %d.\n", 
 *	  set, set_class, set_class->free_set_count); 
 *  fflush(out); 
 */
  if (set) {
    *set = (int) set_class->free_set_list; 
    set_class->free_set_list = set; 
    (set_class->free_set_count)++; 
  }
}
  /* free_set() */



set_size(set, set_class)
     int			*set; 
     struct set_class_type	*set_class; 
{
  int	i, c; 

  for (i = 0, c = 0; i < set_class->universe_size; i++) 
    if (set[i / WORDSIZE] & ELEMENT_MASK[i % WORDSIZE]) 
      c++; 

  return(c); 
}
  /* set_size() */ 




/* Return 1 if i in set; otherwise 0. */
set_membership(i, set, set_class)
     int			i, *set;
     struct set_class_type	*set_class; 
{
  int	mask_index; 

  if (i >= set_class->universe_size) {
    fprintf(out, "\nElement index %d is not in the universe.\n", i); 
    for (mask_index = 1; mask_index; ); 
    exit(1); 
  } 
  else if (i < 0) {
    fprintf(out, "\nElement index %d is not in the universe.\n", i); 
    for (mask_index = 1; mask_index; ); 
    exit(1); 
  } 
  else {
    mask_index = i / WORDSIZE; 
    if (set[mask_index] & ELEMENT_MASK[i % WORDSIZE]) 
      return(TRUE);
    else 
      return(FALSE); 
  }
}
  /* set_membership() */ 


set_emptiness(set, set_class)
     int			*set; 
     struct set_class_type	*set_class; 
{
  int	i; 

  if (set_class->universe_size) {
    for (i = 0; i < set_class->mask_count - 1; i++)
      if (set[i])
	return(FALSE); 
    if (set[i] & set_class->last_mask)
      return(FALSE); 
    else 
      return(TRUE);
  }
  else 
    return(TRUE); 
}
  /* set_emptiness() */



set_overlap(setx, sety, set_class)
     int			*setx, *sety;
     struct set_class_type	*set_class; 
{
  int	*set, i; 

  for (i = 0; i < set_class->mask_count - 1; i++) 
    if (setx[i] & sety[i])
      return(TRUE);

  if ((setx[i] & sety[i]) & set_class->last_mask)
    return(TRUE); 
  else 
    return(FALSE); 
}
  /* set_overlap() */ 





set_contained(setx, sety, set_class)
     int			*setx, *sety;
     struct set_class_type	*set_class; 
{
  int	*set, i; 

  for (i = 0; i < set_class->mask_count - 1; i++) 
    if (setx[i] & ~sety[i])
      return(FALSE);

  if ((setx[i] & ~sety[i]) & set_class->last_mask)
    return(FALSE); 
  else 
    return(TRUE); 
}
  /* set_contained() */ 





set_comp(setx, sety, set_class)
     int			*setx, *sety;
     struct set_class_type	*set_class; 
{
  int	i, mx, my; 

  if (set_class->universe_size) {
    for (i = 0; i < set_class->mask_count - 1; i++)
      if (setx[i] < sety[i])
	return(-1); 
      else if (setx[i] > sety[i]) 
	return(1); 

    mx = setx[i] & set_class->last_mask; 
    my = sety[i] & set_class->last_mask; 
    if (mx < my) 
      return(-1); 
    else if (mx > my) 
      return(1);
    else 
      return(0); 
  }
  else 
    return(0);   
}
  /* set_comp() */ 



set_element_add(i, set, set_class)
     int			i, *set;
     struct set_class_type	*set_class; 
{
  int	mask_index; 

  if (i >= set_class->universe_size) {
    fprintf(out, "\nElement index %d is not in the universe.\n", i); 
    for (mask_index = 1; mask_index; ); 
    exit(2); 
  } 
  else if (i < 0) {
    fprintf(out, "\nElement index %d is not in the universe.\n", i); 
    for (mask_index = 1; mask_index; ); 
    exit(1); 
  } 
  else {
    mask_index = i / WORDSIZE; 
    set[mask_index] = set[mask_index] | ELEMENT_MASK[i % WORDSIZE]; 
  }
}
  /* set_element_add() */ 



set_element_delete(i, set, set_class)
     int			i, *set;
     struct set_class_type	*set_class; 
{
  int	mask_index; 

  if (i >= set_class->universe_size) {
    fprintf(out, "\nElement index %d is not in the universe.\n", i); 
    for (mask_index = 1; mask_index; ); 
    exit(3); 
  } 
  else if (i < 0) {
    fprintf(out, "\nElement index %d is not in the universe.\n", i); 
    for (mask_index = 1; mask_index; ); 
    exit(1); 
  } 
  else {
    mask_index = i / WORDSIZE; 
    set[mask_index] = set[mask_index] & ~ELEMENT_MASK[i % WORDSIZE]; 
  }
}
  /* set_element_delete() */ 



set_type	*set_empty(set_class)
     struct set_class_type	*set_class; 
{
  int	*set; 
  int	i; 

  set = alloc_set(set_class); 
  for (i = 0; i < set_class->mask_count; i++)
    set[i] = 0; 

  return(set); 
}
  /* set_clear() */



set_clear(set, set_class)
     int			*set; 
     struct set_class_type	*set_class; 
{
  int	i; 

  for (i = 0; i < set_class->mask_count; i++)
    set[i] = 0; 
}
  /* set_clear() */



set_type	*set_copy(set, set_class)
     int			*set; 
     struct set_class_type	*set_class; 
{
  int		i; 
  set_type	*ns; 

  ns = alloc_set(set_class); 
  for (i = 0; i < set_class->mask_count; i++)
    ns[i] = set[i]; 

  return(ns); 
}
  /* set_copy() */



set_type	*set_complement(set, set_class)
     int			*set; 
     struct set_class_type	*set_class; 
{
  int		i, j; 
  set_type	*ns; 

  ns = alloc_set(set_class); 
  j = set_class->mask_count - 1; 
  for (i = 0; i < j; i++)
    ns[i] = ~(set[i]); 

  ns[j] = ~(set[j]) & (set_class->last_mask); 

  return(ns); 
}
  /* set_complement() */



*set_write(dest, src, set_class)
     set_type			*dest, *src; 
     struct set_class_type	*set_class; 
{
  int		i; 

  for (i = 0; i < set_class->mask_count; i++)
    dest[i] = src[i]; 
}
  /* set_write() */



int	*set_union(setx, sety, set_class)
     int			*setx, *sety;
     struct set_class_type	*set_class; 
{
  int	*set, i; 

  set = alloc_set(set_class); 

  for (i = 0; i < set_class->mask_count; i++) 
    set[i] = setx[i] | sety[i];

  return(set); 
}
  /* set_union() */ 



set_union_overwrite(setx, sety, set_class)
     int			*setx, *sety;
     struct set_class_type	*set_class; 
{
  int	i; 

  for (i = 0; i < set_class->mask_count; i++) 
    setx[i] = setx[i] | sety[i];
}
  /* set_union_overwrite() */ 



int	*set_intersect(setx, sety, set_class)
     int			*setx, *sety;
     struct set_class_type	*set_class; 
{
  int	*set, i; 

  set = alloc_set(set_class); 

  for (i = 0; i < set_class->mask_count; i++) 
    set[i] = setx[i] & sety[i];

  return(set); 
}
  /* set_intersect() */ 




set_intersect_overwrite(setx, sety, set_class)
     int			*setx, *sety;
     struct set_class_type	*set_class; 
{
  int	i; 

  for (i = 0; i < set_class->mask_count; i++) 
    setx[i] = setx[i] & sety[i];
}
  /* set_intersect_overwrite() */ 



int	*set_subtract(setx, sety, set_class) 
     int			*setx, *sety;
     struct set_class_type	*set_class; 
{
  int	*set, i; 

  set = alloc_set(set_class); 

  for (i = 0; i < set_class->mask_count; i++) 
    set[i] = setx[i] & ~(sety[i]);

  set[set_class->mask_count - 1] 
    = set[set_class->mask_count - 1] & set_class->last_mask; 

  return(set); 
}
  /* set_subtract() */ 



set_subtract_overwrite(setx, sety, set_class) 
     int			*setx, *sety;
     struct set_class_type	*set_class; 
{
  int	i; 

  for (i = 0; i < set_class->mask_count; i++) 
    setx[i] = setx[i] & ~(sety[i]);

  setx[set_class->mask_count - 1] 
    = setx[set_class->mask_count - 1] & set_class->last_mask; 
}
  /* set_subtract() */ 






set_type	*indexed_set_dec(set, index, icount, setclass)
     set_type			*set, *index, icount;
     struct setclass_type	*setclass; 
{
  int	i; 

  for (i = 0; i< icount; i++) 
    if (set[i / WORDSIZE] & ELEMENT_MASK[i % WORDSIZE]) {
      set[i / WORDSIZE] = set[i / WORDSIZE] & ~(ELEMENT_MASK[i % WORDSIZE]); 
      return(set); 
    }
    else {
      set[i / WORDSIZE] = set[i / WORDSIZE] | ELEMENT_MASK[i % WORDSIZE]; 
    }

  return(NULL); 
}
  /* indexed_set_dec() */ 



set_type	*indexed_set_inc(set, index, icount, setclass)
     set_type			*set, *index, icount;
     struct setclass_type	*setclass; 
{
  int	i; 

  for (i = 0; i< icount; i++) 
    if (set[i / WORDSIZE] & ELEMENT_MASK[i % WORDSIZE]) {
      set[i / WORDSIZE] = set[i / WORDSIZE] & ~(ELEMENT_MASK[i % WORDSIZE]); 
    }
    else {
      set[i / WORDSIZE] = set[i / WORDSIZE] | ELEMENT_MASK[i % WORDSIZE]; 
      return(set); 
    }

  return(NULL); 
}
  /* indexed_set_inc() */ 




struct set_link_type	*alloc_set_link()
{
  struct set_link_type	*s; 

  if (free_set_link_count) {
    s = set_link_pool;
    set_link_pool = s->next_set_link; 
    free_set_link_count--; 
  }
  else {
    s = (struct set_link_type *) 
	malloc(sizeof(struct set_link_type)); 
    set_link_count++;
  }
  s->set = NULL; 
  return(s); 
} 
  /* alloc_set_link() */ 


free_set_link(s, set_class)
     struct set_link_type	*s; 
     struct set_class_type	*set_class; 
{
  s->next_set_link = set_link_pool; 
  set_link_pool = s; 
  free_set_link_count++; 
}
  /* free_set_link() */ 




set_test()
{
  struct set_class_type	*sc; 
  char			**name; 
  int			*s1, *s2, i; 

  init_set_management(); 
  name = (char **) malloc(40*sizeof(char *)); 

  name[0] = "Aa"; 
  name[1] = "Bb"; 
  name[2] = "Cc"; 
  name[3] = "Dd"; 
  name[4] = "Ea"; 
  name[5] = "Fb"; 
  name[6] = "Gc"; 
  name[7] = "Hd"; 
  name[8] = "Ia"; 
  name[9] = "Jb"; 
  name[10] = "Kc"; 
  name[11] = "Ld"; 
  name[12] = "Ma"; 
  name[13] = "Nb"; 
  name[14] = "Oc"; 
  name[15] = "Pd"; 
  name[16] = "Qa"; 
  name[17] = "Rb"; 
  name[18] = "Sc"; 
  name[19] = "Td"; 
  name[20] = "Uc"; 
  name[21] = "Vd"; 
  name[22] = "Wa"; 
  name[23] = "Xb"; 
  name[24] = "Yc"; 
  name[25] = "Zd"; 
  name[26] = "0a"; 
  name[27] = "1b"; 
  name[28] = "2c"; 
  name[29] = "3d"; 
  name[30] = "4c"; 
  name[31] = "5d"; 
  name[32] = "6a"; 
  name[33] = "7b"; 
  name[34] = "8c"; 
  name[35] = "9d"; 
  name[36] = "10a"; 
  name[37] = "11b"; 
  name[38] = "12c"; 
  name[39] = "13d"; 
  
  sc = init_setclass_management(40, name); 
  print_set_class(sc); 

  s1 = alloc_set(sc); 

  fprintf(out, "\nInitial set 1 --> "); 
  print_set(s1, sc); 

  for (i = 0; i<40; i = i+3) {
    set_element_add(i, s1, sc); 
    fprintf(out, "\n After add %d:%s --> ", i, name[i]); 
    print_set(s1, sc); 
  }

  for (i = 0; i<40; i = i+5) {
    set_element_delete(i, s1, sc); 
    fprintf(out, "\n After delete %d:%s --> ", i, name[i]); 
    print_set(s1, sc); 
  }
  
  s2 = alloc_set(sc); 
  fprintf(out, "\nInitial set 2 --> "); 
  print_set(s2, sc); 

  for (i = 4; i<40; i = i+4) {
    set_element_add(i, s2, sc); 
    fprintf(out, "\n After add %d:%s --> ", i, name[i]); 
    print_set(s2, sc); 
  }

  fprintf(out, "\nUnion of s1 and s2 :\n"); 
  print_set(set_union(s1, s2, sc), sc); 

  fprintf(out, "\nIntersection of s1 and s2 :\n"); 
  print_set(set_intersect(s1, s2, sc), sc); 
}
  /* set_test() */ 


